var _excluded = ["children", "caption", "type"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import locale from './../locale'; // type: loading,noMore,failed

var BottomFinish = forwardRef(function (_ref, ref) {
  var children = _ref.children,
      caption = _ref.caption,
      type = _ref.type,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return rootRef.current;
  }); // 获取提示

  function getCaption() {
    if (caption) return caption;

    if (type === 'loading') {
      return /*#__PURE__*/React.createElement("div", {
        className: "body-pull-push-box"
      }, /*#__PURE__*/React.createElement("div", {
        className: "body-pull-push-icon body-pull-push-icon-loading"
      }), /*#__PURE__*/React.createElement("div", {
        className: "body-pull-push-caption"
      }, locale('正在加载...', 'loading')));
    } else {
      return /*#__PURE__*/React.createElement("div", {
        className: "body-pull-push-box"
      }, /*#__PURE__*/React.createElement("div", {
        className: "body-pull-push-caption"
      }, type === 'noMore' ? locale('没有更多数据了', 'no_more_data') : locale('加载失败, 请稍后再试', 'refreshing_failed')));
    }
  }

  return /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef,
    className: "SID-Dragrefresh-ErrorContainer body-pull-push",
    style: {
      height: '50px'
    }
  }, others), !children && getCaption(), children);
});
export default BottomFinish;