import _regeneratorRuntime from "@babel/runtime/regenerator";
var _excluded = ["type", "isProvince", "isCity", "isDistrict", "list", "loadList", "onBeforeSelectOption"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useEffect, useRef, useState } from 'react';
import CascaderCombo from './../Combo'; // 级联选择

export default forwardRef(function (_ref, ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? '' : _ref$type,
      isProvince = _ref.isProvince,
      isCity = _ref.isCity,
      isDistrict = _ref.isDistrict,
      list = _ref.list,
      loadList = _ref.loadList,
      onBeforeSelectOption = _ref.onBeforeSelectOption,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var listData = useRef(list);

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1];

  useEffect(function () {
    initList();
  }, []); // eslint-disable-line

  function initList() {
    return _initList.apply(this, arguments);
  } // 点击选项前判断是否指定类型: 省, 市, 区


  function _initList() {
    _initList = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              listData.current = list; // 列表存在则显示弹窗

              if (!(Array.isArray(listData.current) && listData.current.length)) {
                _context.next = 4;
                break;
              }

              setVisible(true);
              return _context.abrupt("return");

            case 4:
              if (!(typeof loadList === 'function')) {
                _context.next = 8;
                break;
              }

              _context.next = 7;
              return loadList();

            case 7:
              listData.current = _context.sent;

            case 8:
              if (!(Array.isArray(listData.current) && listData.current.length)) {
                _context.next = 11;
                break;
              }

              setVisible(true);
              return _context.abrupt("return");

            case 11:
              // 读取默认列表或者缓存
              if (Object.isEmptyObject(window.__SeedsUI_Cascader_DistrictCombo_list__)) {
                window.__SeedsUI_Cascader_DistrictCombo_list__ = require('./China');

                if (window.__SeedsUI_Cascader_DistrictCombo_list__["default"]) {
                  window.__SeedsUI_Cascader_DistrictCombo_list__ = window.__SeedsUI_Cascader_DistrictCombo_list__["default"];
                }
              }

              listData.current = window.__SeedsUI_Cascader_DistrictCombo_list__ || null;
              setVisible(true);

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _initList.apply(this, arguments);
  }

  function handleBeforeSelectOption(tabs) {
    if (!type) return true;
    if (!Array.isArray(tabs) || !tabs.length) return true; // 自行解决省市区判断

    if (onBeforeSelectOption) return onBeforeSelectOption(tabs); // 获取当前选中项

    var lastTab = tabs[tabs.length - 1]; // 获取所有省市, 用于匹配选中的省市

    if (Object.isEmptyObject(window.__SeedsUI_Cascader_DistrictCombo_areaLevel__)) {
      window.__SeedsUI_Cascader_DistrictCombo_areaLevel__ = require('./ChinaAreaLevel');

      if (window.__SeedsUI_Cascader_DistrictCombo_areaLevel__["default"]) {
        window.__SeedsUI_Cascader_DistrictCombo_areaLevel__ = window.__SeedsUI_Cascader_DistrictCombo_areaLevel__["default"];
      }
    }

    var AreaLevel = window.__SeedsUI_Cascader_DistrictCombo_areaLevel__ || null;
    if (!AreaLevel) return true; // 匹配省名, id相同或者名称相近即可匹配, 因为省是一级

    if (type === 'province') {
      if (typeof isProvince === 'function') {
        return isProvince(lastTab);
      }

      if (lastTab.isProvince) {
        return true;
      }

      for (var _iterator = _createForOfIteratorHelperLoose(AreaLevel.provinces), _step; !(_step = _iterator()).done;) {
        var province = _step.value;

        if (lastTab.id === province.id || province.name.indexOf(lastTab.name) !== -1 || lastTab.name.indexOf(province.name) !== -1) {
          return false;
        }
      }
    } // 匹配市名, id相同或者包含市, 因为吉林省吉林市不能根据名称匹配, 否则可能会选到省
    else if (type === 'city') {
        if (typeof isCity === 'function') {
          return isCity(lastTab);
        }

        if (lastTab.isCity) {
          return true;
        }

        for (var _iterator2 = _createForOfIteratorHelperLoose(AreaLevel.cities), _step2; !(_step2 = _iterator2()).done;) {
          var city = _step2.value;

          if (lastTab.id === city.id || lastTab.name.indexOf('市') !== -1) {
            return false;
          }
        }
      } // 区判断
      else if (type === 'district') {
          if (typeof isDistrict === 'function') {
            return isDistrict(lastTab);
          }

          if (lastTab.isDistrict) {
            return false;
          }
        }

    return true;
  }

  if (!visible) return null;
  return /*#__PURE__*/React.createElement(CascaderCombo, _extends({
    onBeforeSelectOption: handleBeforeSelectOption,
    ref: ref,
    list: listData.current
  }, props));
});