import _regeneratorRuntime from "@babel/runtime/regenerator";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import React from 'react';
import Utils from './Utils';

function Tabs(_ref) {
  var list = _ref.list,
      loadData = _ref.loadData,
      currentList = _ref.currentList,
      onCurrentListChange = _ref.onCurrentListChange,
      tabs = _ref.tabs,
      onTabsChange = _ref.onTabsChange,
      chooseTab = _ref.chooseTab,
      onChooseTabChange = _ref.onChooseTabChange;

  // 点击Tab
  function handleTabClick(e, tab) {
    // 传入的选中项可能会数据不充分, 需要补充数据
    tab = Utils.getListNode(list, tab);
    e.stopPropagation(); // 选中点击Tab

    handleActiveTab(tab); // 修改当前列表

    handleTabList(tab);
  } // 点击请选择


  function handleChooseClick(_x, _x2) {
    return _handleChooseClick.apply(this, arguments);
  } // 更新Tabs选中状态


  function _handleChooseClick() {
    _handleChooseClick = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(e, tab) {
      var newCurrentList;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              e.stopPropagation(); // 传入的选中项可能会数据不充分, 需要补充数据

              tab = Utils.getListNode(list, tab);
              _context.next = 4;
              return Utils.getChildrenList(list, tabs, tab, loadData);

            case 4:
              newCurrentList = _context.sent;

              // 有子列表, 则渲染子列表, 并显示请选择
              if (Array.isArray(newCurrentList) && newCurrentList.length) {
                if (onCurrentListChange) onCurrentListChange(newCurrentList); // 选中请选择

                chooseTab.active = true; // 取消页签选中

                tabs = tabs.map(function (item) {
                  delete item.active;
                  return item;
                });
                if (onTabsChange) onTabsChange(tabs);
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleChooseClick.apply(this, arguments);
  }

  function handleActiveTab(tab) {
    // 选择tab取消选中状态
    if (chooseTab === null || chooseTab === void 0 ? void 0 : chooseTab.active) {
      chooseTab.active = false;
    } // 选中点击节点


    if (!(tab === null || tab === void 0 ? void 0 : tab.id)) return;
    tabs = tabs.map(function (item) {
      if (item.id === tab.id) {
        item.active = true;
      } else {
        delete item.active;
      }

      return item;
    });
    if (onTabsChange) onTabsChange(tabs);
  } // 更新列表


  function handleTabList(_x3) {
    return _handleTabList.apply(this, arguments);
  } // 获取Tabs的DOM


  function _handleTabList() {
    _handleTabList = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(tab) {
      var _iterator2, _step2, item, newCurrentList;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _iterator2 = _createForOfIteratorHelperLoose(tabs);

            case 1:
              if ((_step2 = _iterator2()).done) {
                _context2.next = 8;
                break;
              }

              item = _step2.value;

              if (!item.active) {
                _context2.next = 6;
                break;
              }

              tab = item;
              return _context2.abrupt("break", 8);

            case 6:
              _context2.next = 1;
              break;

            case 8:
              _context2.next = 10;
              return Utils.getSiblingList(list, tabs, tab, loadData);

            case 10:
              newCurrentList = _context2.sent;
              if (!newCurrentList || !newCurrentList.length) debugger;
              if (onCurrentListChange) onCurrentListChange(newCurrentList);

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _handleTabList.apply(this, arguments);
  }

  function getTabsDOM() {
    // 页签
    var tabsNode = [];

    if (Array.isArray(tabs) && tabs.length) {
      var _loop = function _loop() {
        var _step$value = _step.value,
            index = _step$value[0],
            tab = _step$value[1];
        tabsNode.push( /*#__PURE__*/React.createElement("div", {
          onClick: function onClick(e) {
            return handleTabClick(e, tab);
          },
          className: "cascader-tab" + (tab.active ? ' active' : ''),
          key: index
        }, tab.name));
      };

      for (var _iterator = _createForOfIteratorHelperLoose(tabs.entries()), _step; !(_step = _iterator()).done;) {
        _loop();
      }
    } // 请选择


    if (chooseTab) {
      tabsNode.push( /*#__PURE__*/React.createElement("div", {
        onClick: function onClick(e) {
          return handleChooseClick(e, chooseTab);
        },
        className: "cascader-tab" + (chooseTab.active ? ' active' : ''),
        key: chooseTab.id
      }, chooseTab.name));
    }

    return tabsNode;
  }

  if (!Array.isArray(list) || !list.length) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: "cascader-tabs"
  }, getTabsDOM());
}

export default Tabs;