var _excluded = ["type", "value", "checked", "disabled", "inputProps", "captionProps", "children", "onChange"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle } from 'react';
var Checkbox = forwardRef(function (_ref, ref) {
  var type = _ref.type,
      value = _ref.value,
      checked = _ref.checked,
      disabled = _ref.disabled,
      _ref$inputProps = _ref.inputProps,
      inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
      _ref$captionProps = _ref.captionProps,
      captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
      children = _ref.children,
      onChange = _ref.onChange,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 节点
  var rootRef = useRef(null);
  var inputRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInputDOM: function getInputDOM() {
        return inputRef.current;
      }
    };
  }); // 点击回调

  function handleClick(e) {
    if (disabled) return;
    if (onChange) onChange(e.currentTarget.getAttribute('data-checked') !== 'true');
  } // 类型样式前缀


  var typeClassPrefix = type === 'radio' ? 'radio' : 'checkbox';
  return /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef
  }, others, {
    onClick: handleClick,
    disabled: disabled,
    "data-checked": checked,
    "data-value": value,
    className: "" + typeClassPrefix + (others.className ? ' ' + others.className : '')
  }), /*#__PURE__*/React.createElement("span", _extends({
    ref: inputRef
  }, inputProps, {
    className: typeClassPrefix + "-input" + (inputProps.className ? ' ' + inputProps.className : '')
  })), (children || (captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption)) && /*#__PURE__*/React.createElement("div", _extends({}, captionProps, {
    className: typeClassPrefix + "-caption" + (captionProps.className ? ' ' + captionProps.className : '')
  }), captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption, children));
});
export default Checkbox;