function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState, useEffect } from 'react';
import Alert from './../Alert';
import InputDate from './../InputDate';
import locale from './../locale'; // 自定义时间

function DateRange(_ref) {
  var caption = _ref.caption,
      type = _ref.type,
      start = _ref.start,
      end = _ref.end,
      _ref$startInputDatePr = _ref.startInputDateProps,
      startInputDateProps = _ref$startInputDatePr === void 0 ? {} : _ref$startInputDatePr,
      _ref$endInputDateProp = _ref.endInputDateProps,
      endInputDateProps = _ref$endInputDateProp === void 0 ? {} : _ref$endInputDateProp,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      onSubmitBefore = _ref.onSubmitBefore,
      onChange = _ref.onChange;

  // 自定义日期数据
  var _useState = useState(start),
      customStart = _useState[0],
      setCustomStart = _useState[1];

  var _useState2 = useState(end),
      customEnd = _useState2[0],
      setCustomEnd = _useState2[1];

  useEffect(function () {
    setCustomStart(start);
    setCustomEnd(end);
  }, [start, end]); // 点击自定义取消

  function handleCustomCancel() {
    if (onVisibleChange) onVisibleChange(false);
    setCustomStart(start);
    setCustomEnd(end);
  } // 点击自定义确定


  function handleCustomSubmit(e) {
    if (typeof onSubmitBefore === 'function') {
      if (!onSubmitBefore(e, [customStart, customEnd])) {
        return;
      }
    }

    if (onChange) {
      onChange(e, [customStart, customEnd]);
    }

    if (onVisibleChange) onVisibleChange(false);
  } // 修改自定义开始时间


  function handleCustomStartDate(e, value) {
    setCustomStart(value);
  } // 修改自定义结束时间


  function handleCustomEndDate(e, value) {
    setCustomEnd(value);
  }

  return /*#__PURE__*/React.createElement(Alert, {
    caption: caption || '',
    show: visible,
    submitAttribute: {
      onClick: handleCustomSubmit
    },
    cancelAttribute: {
      onClick: handleCustomCancel
    }
  }, /*#__PURE__*/React.createElement(InputDate, _extends({
    type: type || 'date',
    max: customEnd,
    value: customStart || start || '',
    onChange: handleCustomStartDate,
    placeholder: locale('请选择'),
    className: "datepopover-dialog-inputbox",
    pickerProps: {
      maskAttribute: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, startInputDateProps || {})), /*#__PURE__*/React.createElement(InputDate, _extends({
    type: type || 'date',
    min: customStart,
    value: customEnd || end || '',
    onChange: handleCustomEndDate,
    placeholder: locale('请选择'),
    className: "datepopover-dialog-inputbox",
    pickerProps: {
      maskAttribute: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, endInputDateProps || {})));
}

export default DateRange;