var _excluded = ["disabled", "readOnly", "value", "onChange"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useState } from 'react';
import InputText from './../../InputText';
import Dialog from './../../Dialog';
import locale from './../../locale';
import MapSearch from './../../MapSearch';
import helper from './helper';
export default (function (_ref) {
  var _Object$keys, _ref2;

  var disabled = _ref.disabled,
      readOnly = _ref.readOnly,
      value = _ref.value,
      onChange = _ref.onChange,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState([]),
      list = _useState2[0],
      setList = _useState2[1];

  var _useState3 = useState({}),
      selected = _useState3[0],
      setSelected = _useState3[1];

  useEffect(function () {
    setSelected(value || {});
  }, []); // eslint-disable-line

  var handleClick = function handleClick() {
    setVisible(true);
  };

  var handleMapClose = function handleMapClose() {
    setVisible(false);
  };

  var handleMapLocation = function handleMapLocation(list) {
    setList(list);
  };

  var handleChange = function handleChange(e) {
    helper.localSearch(e.target.value, handleMapLocation);
  };

  var handleCardClick = function handleCardClick(item) {
    var l = item.point;
    var list = [{
      lng: l.lng,
      lat: l.lat
    }];
    helper.setNewCenter(list);
    helper.drawMarkers(list);
    setSelected(item);
    onChange && onChange(item);
    handleMapClose();
  };

  var handleClear = function handleClear(e) {
    e.stopPropagation();
    setSelected({});
    onChange && onChange(null);
  };

  var handleCallback = function handleCallback(value) {
    helper.localSearch(value, handleMapLocation);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, selected && ((_Object$keys = Object.keys(selected || {})) === null || _Object$keys === void 0 ? void 0 : _Object$keys.length) > 0 ? /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      return setVisible(true);
    },
    style: (_ref2 = {
      minHeight: '40px',
      padding: '6px 12px',
      display: 'flex'
    }, _ref2["padding"] = 0, _ref2)
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex-1"
  }, /*#__PURE__*/React.createElement("div", null, selected.title || ''), /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#707070'
    }
  }, selected.address || '')), /*#__PURE__*/React.createElement("div", {
    style: {
      margin: 'auto'
    }
  }, /*#__PURE__*/React.createElement("i", {
    className: "icon icon-rdo-close-fill size18",
    style: {
      color: '#707070'
    },
    onClick: handleClear
  }))) : /*#__PURE__*/React.createElement(InputText, _extends({
    readOnly: true,
    className: "bg-white",
    placeholder: disabled || readOnly ? '' : locale('请选择'),
    inputAttribute: {
      style: {
        padding: 0
      }
    },
    style: {
      padding: 0,
      borderRadius: 4
    },
    ricon: disabled || readOnly ? null : /*#__PURE__*/React.createElement("i", {
      className: "input-location-icon-choose",
      style: {
        width: 24,
        height: 24,
        backgroundRepeat: 'no-repeat',
        backgroundSize: '100% 100%'
      }
    }),
    onClick: handleClick
  }, others)), visible && /*#__PURE__*/React.createElement(Dialog, {
    portal: document.getElementById('root'),
    show: visible,
    animation: "slideUp",
    style: {
      width: '100%',
      height: '90%',
      borderRadius: '18px 18px 0 0',
      backgroundColor: '#ffffff'
    }
  }, /*#__PURE__*/React.createElement(MapSearch, {
    callback: handleCallback
  })));
});