var _excluded = ["portal", "type", "maskProps", "icon", "iconProps", "captionProps", "children"],
    _excluded2 = ["caption"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
import locale from './../locale'; // 国际化数据

var Loading = forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'floating' : _ref$type,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      icon = _ref.icon,
      iconProps = _ref.iconProps,
      _ref$captionProps = _ref.captionProps,
      captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = useRef(null);
  var containerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });

  var _captionProps$caption = captionProps.caption,
      caption = _captionProps$caption === void 0 ? locale('加载中...', 'loading') : _captionProps$caption,
      otherCaptionProps = _objectWithoutPropertiesLoose(captionProps, _excluded2);

  var content = null;

  if (type === 'custom') {
    // 自定义样式
    content = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-custom" + (props.className ? ' ' + props.className : '')
    }), icon && icon, iconProps && /*#__PURE__*/React.createElement("span", _extends({}, iconProps, {
      className: "loading-custom-icon" + (iconProps.className ? ' ' + iconProps.className : '')
    })), caption && /*#__PURE__*/React.createElement("p", _extends({}, otherCaptionProps, {
      className: "loading-custom-caption" + (otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  } else if (type === 'filling') {
    // 填料环
    content = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-filling active" + (props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-filling-icon"
    }));
  } else if (type === 'floating') {
    // 流光
    content = /*#__PURE__*/React.createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-floating animated" + (props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-icon"
    }, /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    })), caption && /*#__PURE__*/React.createElement("div", _extends({}, otherCaptionProps, {
      className: "loading-floating-caption" + (otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  } // 组合Node


  var Node = /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef
  }, maskProps, {
    className: 'loading-mask mask active' + (maskProps.className ? ' ' + maskProps.className : '')
  }), content, children);

  if (portal) {
    return createPortal(Node, portal);
  }

  return Node;
});
export default Loading;