import _regeneratorRuntime from "@babel/runtime/regenerator";
var _excluded = ["cacheTime", "timeout", "ak", "locationVisible", "autoLocation", "chooseVisible", "previewVisible", "failText", "loadingText", "readOnly", "disabled", "value", "onChange", "onError", "onClick", "inputProps"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle, useState, useEffect, Fragment } from 'react';
import Input from './../../Input';
import Bridge from './../../Bridge';
import locale from './../../locale';
import Modal from './../Modal';
import Utils from './Utils'; // 定位控件

var LocationCombo = forwardRef(function (_ref, ref) {
  var _ref$cacheTime = _ref.cacheTime,
      cacheTime = _ref$cacheTime === void 0 ? 10000 : _ref$cacheTime,
      timeout = _ref.timeout,
      ak = _ref.ak,
      _ref$locationVisible = _ref.locationVisible,
      locationVisible = _ref$locationVisible === void 0 ? true : _ref$locationVisible,
      _ref$autoLocation = _ref.autoLocation,
      autoLocation = _ref$autoLocation === void 0 ? false : _ref$autoLocation,
      _ref$chooseVisible = _ref.chooseVisible,
      chooseVisible = _ref$chooseVisible === void 0 ? false : _ref$chooseVisible,
      _ref$previewVisible = _ref.previewVisible,
      previewVisible = _ref$previewVisible === void 0 ? false : _ref$previewVisible,
      _ref$failText = _ref.failText,
      failText = _ref$failText === void 0 ? locale('定位失败, 请检查定位权限是否开启', 'hint_location_failed') : _ref$failText,
      _ref$loadingText = _ref.loadingText,
      loadingText = _ref$loadingText === void 0 ? locale('定位中...', 'location') : _ref$loadingText,
      _ref$readOnly = _ref.readOnly,
      readOnly = _ref$readOnly === void 0 ? true : _ref$readOnly,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      value = _ref.value,
      _onChange = _ref.onChange,
      onError = _ref.onError,
      onClick = _ref.onClick,
      inputProps = _ref.inputProps,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 显示预览preview、选择choose
  var _useState = useState(''),
      modalVisible = _useState[0],
      setModalVisible = _useState[1]; // 定位状态, -1.定位中; 0.定位失败时隐藏text框, 显示定位中或者定位失败的div; 1定位成功显示文本框


  var _useState2 = useState('1'),
      locationStatus = _useState2[0],
      setLocationStatus = _useState2[1];

  var onChangeRef = useRef();
  onChangeRef.current = _onChange;
  var onErrorRef = useRef();
  onErrorRef.current = onError; // 节点

  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        var _rootRef$current;

        // div
        var rootDOM = rootRef === null || rootRef === void 0 ? void 0 : rootRef.current; // Input.Text

        if (rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.getRootDOM) {
          rootDOM = rootRef.current.getRootDOM();
        }

        return rootDOM;
      }
    };
  }); // 自动定位

  useEffect(function () {
    if (autoLocation !== true) return;
    handleAutoLocation();
  }, [autoLocation]); // eslint-disable-line
  // 自动定位

  function handleAutoLocation() {
    return _handleAutoLocation.apply(this, arguments);
  } // 点击文本框


  function _handleAutoLocation() {
    _handleAutoLocation = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var result, address;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(value && value.latitude && value.longitude)) {
                _context.next = 15;
                break;
              }

              if (!value.address) {
                _context.next = 5;
                break;
              }

              // 有地址, 则定位完成
              if (onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current) {
                onChangeRef.current(value);
              }

              _context.next = 13;
              break;

            case 5:
              // 无地址, 则需要地址逆解析
              locationStatus = '-1';
              setLocationStatus('-1'); // 定位中...

              _context.next = 9;
              return Bridge.getAddress({
                // 只支持gcj02
                latitude: value.latitude,
                longitude: value.longitude
              });

            case 9:
              result = _context.sent;
              address = result && result.address ? result.address : '';
              result.value = address;

              if (address) {
                locationStatus = '1';
                setLocationStatus('1'); // 回调onChange

                if (onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current) {
                  onChangeRef.current(result);
                }
              } else {
                locationStatus = '0';
                setLocationStatus('0');
              }

            case 13:
              _context.next = 16;
              break;

            case 15:
              handleLocation();

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleAutoLocation.apply(this, arguments);
  }

  function handleClick(e) {
    e.stopPropagation();
    if (onClick) onClick(e); // 正在定位不允许操作

    if (locationStatus === '-1') {
      return;
    } // 点击输入


    if (!readOnly) {
      if (locationStatus === '0') {
        // 非只读状态下, 点击错误面板, 允许手动输入位置
        locationStatus = '1';
        setLocationStatus('1');
      }

      return;
    } // 点击整行定位


    if (readOnly && locationVisible) {
      handleLocation(e);
      return;
    } // 点击整行预览


    if (readOnly && previewVisible) {
      setModalVisible('preview');
      return;
    }
  } // 定位, isAutoLocation表示初始化时自动定位


  function handleLocation(e) {
    if (e) {
      e.stopPropagation();
    } // 定位中...


    locationStatus = '-1';
    setLocationStatus('-1'); // 定位超时处理

    if (typeof timeout === 'number') {
      if (Number(timeout) < 1000) {
        console.warn('InputLocation: 超时参数timeout不能小于1000毫秒');
      } else {
        if (rootRef.current.locationTimeout) window.clearTimeout(rootRef.current.locationTimeout);
        rootRef.current.locationTimeout = setTimeout(function () {
          if (locationStatus === '-1') {
            if (onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current) {
              onChangeRef.current(null);
            }

            if (onErrorRef === null || onErrorRef === void 0 ? void 0 : onErrorRef.current) {
              onErrorRef.current({
                errMsg: "getLocation:fail" + locale('定位超时', 'hint_location_timeout')
              });
            }

            locationStatus = '0';
            setLocationStatus('0');
          }
        }, timeout);
      }
    } // 开始定位


    Utils.getLocation({
      cacheTime: cacheTime,
      onChange: function onChange(newValue) {
        // 定位超时后不再执行回调
        if (locationStatus === '0') {
          console.log('定位超时, 不再执行成功回调');
          return;
        } // 定位失败


        if (!newValue) {
          if (onErrorRef === null || onErrorRef === void 0 ? void 0 : onErrorRef.current) {
            onErrorRef.current({
              errMsg: "getLocation:fail" + failText
            });
          }

          locationStatus = '0';
          setLocationStatus('0');
        } // 定位成功
        else {
            locationStatus = '1';
            setLocationStatus('1');
          } // 回调onChange


        if (onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current) {
          onChangeRef.current(newValue);
        }
      }
    });
  } // 定位和选择按钮


  function getRiconNode() {
    if (disabled) return null;
    var riconNode = []; // 显示选择

    if (chooseVisible) {
      riconNode.push( /*#__PURE__*/React.createElement("i", {
        key: "choose",
        className: "ricon icon location-combo-icon size24 location-combo-icon-choose",
        onClick: function onClick(e) {
          e.stopPropagation();
          setModalVisible('choose');
        }
      }));
    } // 显示预览


    if (previewVisible) {
      riconNode.push( /*#__PURE__*/React.createElement("i", {
        key: "preview",
        className: "ricon icon location-combo-icon size24 location-combo-icon-choose",
        onClick: function onClick(e) {
          e.stopPropagation();
          setModalVisible('preview');
        }
      }));
    } // 显示定位


    if (locationVisible) {
      riconNode.push( /*#__PURE__*/React.createElement("i", {
        key: "location",
        className: "ricon icon location-combo-icon size24 location-combo-icon-location",
        onClick: handleLocation
      }));
    }

    return riconNode;
  } // 加载和错误面板, 显示这些面板时将会隐藏文本框, 样式必须与文本框一致


  var statusNode = null;

  if (locationStatus === '-1') {
    statusNode = /*#__PURE__*/React.createElement("div", {
      className: "input-text " + ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.className) || '') + " location-combo",
      style: (inputProps === null || inputProps === void 0 ? void 0 : inputProps.style) || {}
    }, loadingText);
  } else if (locationStatus === '0') {
    statusNode = /*#__PURE__*/React.createElement("div", {
      className: "input-text " + ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.className) || '') + " location-combo-error",
      style: (inputProps === null || inputProps === void 0 ? void 0 : inputProps.style) || {}
    }, failText);
  }

  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Input.Text, _extends({
    ref: rootRef,
    readOnly: readOnly,
    disabled: disabled,
    onClick: handleClick,
    onChange: function onChange(address) {
      var newValue = Object.clone(value);

      if (!newValue) {
        newValue = {};
      }

      newValue.value = address;
      if (_onChange) _onChange(newValue);
    },
    children: statusNode,
    value: value && typeof value === 'object' ? (value === null || value === void 0 ? void 0 : value.value) || '' : value || ''
  }, props, {
    ricon: /*#__PURE__*/React.createElement(React.Fragment, null, getRiconNode()),
    inputProps: Object.assign({}, inputProps, {
      // 定位中和定位失败时隐藏text框, 显示定位中或者定位失败的div
      visible: statusNode ? false : true,
      className: 'location-combo-success' + ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.className) ? '' + (inputProps === null || inputProps === void 0 ? void 0 : inputProps.className) : '')
    })
  })), /*#__PURE__*/React.createElement(Modal, {
    value: value,
    visible: modalVisible,
    onVisibleChange: function onVisibleChange() {
      return setModalVisible('');
    },
    onChange: function onChange(newValue) {
      if (newValue.address && (onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current)) {
        onChangeRef.current(newValue);
      }
    }
  }));
});
export default LocationCombo;