var _excluded = ["ak", "value", "onChange", "visible", "onVisibleChange"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import Modal from './../../Modal';
import Preview from './Map/Preview';
import Choose from './Map/Choose'; // 地图标注

var LocationModal = forwardRef(function (_ref, ref) {
  var ak = _ref.ak,
      value = _ref.value,
      onChange = _ref.onChange,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  function handleChange(newValue) {
    if (onChange) onChange(newValue);
    if (onVisibleChange) onVisibleChange(false);
  }

  return /*#__PURE__*/React.createElement(Modal, _extends({
    ref: ref,
    visible: visible,
    onVisibleChange: onVisibleChange
  }, props, {
    animation: "slideUp",
    className: "location-modal"
  }), visible === 'preview' && /*#__PURE__*/React.createElement(Preview, {
    ak: ak,
    value: value
  }), visible === 'choose' && /*#__PURE__*/React.createElement(Choose, {
    ak: ak,
    value: value,
    onChange: handleChange
  }));
});
export default LocationModal;