var _excluded = ["portal", "animation", "visible", "maskClosable", "onVisibleChange", "maskProps", "captionProps", "submitProps", "cancelProps", "children"],
    _excluded2 = ["caption"],
    _excluded3 = ["caption", "onClick"],
    _excluded4 = ["caption", "onClick"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, useRef, forwardRef } from 'react';
import { createPortal } from 'react-dom';
import Utils from './../Tooltip/Utils';
import locale from './../locale';
var Modal = forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'zoom' : _ref$animation,
      visible = _ref.visible,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$captionProps = _ref.captionProps,
      captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 增加保护
  if (!maskProps) maskProps = {};
  if (!captionProps) captionProps = {};
  if (!submitProps) submitProps = {};
  if (!cancelProps) cancelProps = {};
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 构建动画

  var position = Utils.getAnimationPosition(animation); // 判断是否是要生成Alert框

  function getIsAlert() {
    var _captionProps = captionProps,
        titleText = _captionProps.caption;
    var _cancelProps = cancelProps,
        cancelText = _cancelProps.caption,
        cancelClick = _cancelProps.onClick;
    var _submitProps = submitProps,
        submitText = _submitProps.caption,
        submitClick = _submitProps.onClick;
    if (titleText || cancelText || cancelClick || submitText || submitClick) return true;
    return false;
  } // 获取内容


  function getChildren() {
    // 标题
    var caption = null;

    var _captionProps2 = captionProps,
        titleText = _captionProps2.caption,
        otherCaptionProps = _objectWithoutPropertiesLoose(_captionProps2, _excluded2);

    if (titleText) {
      caption = /*#__PURE__*/React.createElement("div", _extends({}, otherCaptionProps, {
        className: "modal-caption" + (otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
      }), titleText);
    } // 底部


    var footer = []; // 取消

    var _cancelProps2 = cancelProps,
        cancelText = _cancelProps2.caption,
        cancelClick = _cancelProps2.onClick,
        otherCancelProps = _objectWithoutPropertiesLoose(_cancelProps2, _excluded3);

    if (cancelText || cancelClick) {
      footer.push( /*#__PURE__*/React.createElement("div", _extends({
        key: "footer-cancel",
        onClick: handleCancel
      }, otherCancelProps, {
        className: "modal-cancel button" + (otherCancelProps.className ? ' ' + otherCancelProps.className : '')
      }), cancelText || locale('取消', 'cancel')));
    } // 确定


    var _submitProps2 = submitProps,
        submitText = _submitProps2.caption,
        submitClick = _submitProps2.onClick,
        otherSubmitProps = _objectWithoutPropertiesLoose(_submitProps2, _excluded4);

    if (submitText || submitClick) {
      footer.push( /*#__PURE__*/React.createElement("div", _extends({
        key: "footer-ok",
        onClick: handleSubmit
      }, otherSubmitProps, {
        className: "modal-ok button" + (otherSubmitProps.className ? ' ' + otherSubmitProps.className : '')
      }), submitText || locale('确定', 'ok')));
    }

    if (footer.length) {
      footer = /*#__PURE__*/React.createElement("div", {
        className: "modal-footer"
      }, footer);
    } else {
      footer = null;
    } // 有标题或者有底部时


    if (caption || footer) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: "modal-body"
      }, caption, /*#__PURE__*/React.createElement("div", {
        className: "modal-content"
      }, children)), footer);
    }

    return children;
  } // 点击遮罩


  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  } // 点击模态框


  function handleModalClick(e) {
    e.stopPropagation();
  } // 点击确定或者取消按钮


  function handleButton(e, buttonProps) {
    if (typeof (buttonProps === null || buttonProps === void 0 ? void 0 : buttonProps.onClick) === 'function') {
      var _buttonProps$onClick;

      var close = (_buttonProps$onClick = buttonProps.onClick()) !== null && _buttonProps$onClick !== void 0 ? _buttonProps$onClick : true;

      if (close) {
        if (onVisibleChange) onVisibleChange(false);
      }
    } else {
      if (onVisibleChange) onVisibleChange(false);
    }

    e.stopPropagation();
  } // 点击确定


  function handleSubmit(e) {
    handleButton(e, submitProps);
  } // 点击取消


  function handleCancel(e) {
    handleButton(e, cancelProps);
  } // 获取激活状态样式


  function getActiveClass() {
    return visible ? ' active' : '';
  }

  return createPortal( /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef,
    className: "mask modal-mask" + (maskProps.className ? ' ' + maskProps.className : '') + getActiveClass()
  }, maskProps, {
    onClick: handleMaskClick
  }), /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "popup-animation modal" + (getIsAlert() ? ' modal-alert' : '') + (position ? ' ' + position : '') + (props.className ? ' ' + props.className : '') + getActiveClass(),
    "data-animation": animation,
    onClick: handleModalClick
  }), getChildren())), portal || document.getElementById('root') || document.body);
});
export default Modal;