import _regeneratorRuntime from "@babel/runtime/regenerator";
var _excluded = ["ModalComponent", "ModalProps", "maskProps", "submitProps", "cancelProps", "slotProps", "portal", "maskClosable", "multiple", "value", "list", "onBeforeChange", "onChange", "allowClear", "readOnly", "disabled", "onBeforeOpen", "children"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle, Fragment, useState } from 'react';
import Input from './../../Input';
import Modal from './../Modal';
import Utils from './Utils';
var Combo = forwardRef(function (_ref, ref) {
  var ModalComponent = _ref.ModalComponent,
      _ref$ModalProps = _ref.ModalProps,
      ModalProps = _ref$ModalProps === void 0 ? {} : _ref$ModalProps,
      maskProps = _ref.maskProps,
      submitProps = _ref.submitProps,
      cancelProps = _ref.cancelProps,
      slotProps = _ref.slotProps,
      portal = _ref.portal,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      multiple = _ref.multiple,
      value = _ref.value,
      _ref$list = _ref.list,
      list = _ref$list === void 0 ? [] : _ref$list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      allowClear = _ref.allowClear,
      readOnly = _ref.readOnly,
      disabled = _ref.disabled,
      onBeforeOpen = _ref.onBeforeOpen,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = useRef(null);
  var modalRef = useRef(null);
  useImperativeHandle(ref, function () {
    var _modalRef$current, _modalRef$current2;

    return {
      getRootDOM: function getRootDOM() {
        var _rootRef$current;

        // div
        var rootDOM = rootRef === null || rootRef === void 0 ? void 0 : rootRef.current; // Input.Text

        if (rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.getRootDOM) {
          rootDOM = rootRef.current.getRootDOM();
        }

        return rootDOM;
      },
      getModalDOM: modalRef === null || modalRef === void 0 ? void 0 : (_modalRef$current = modalRef.current) === null || _modalRef$current === void 0 ? void 0 : _modalRef$current.getRootDOM,
      getInstance: modalRef === null || modalRef === void 0 ? void 0 : (_modalRef$current2 = modalRef.current) === null || _modalRef$current2 === void 0 ? void 0 : _modalRef$current2.getInstance
    };
  }); // 控制Modal显隐

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1]; // 点击文本框


  function handleInputClick() {
    return _handleInputClick.apply(this, arguments);
  } // 默认使用Picker弹窗


  function _handleInputClick() {
    _handleInputClick = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var goOn;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(readOnly || disabled)) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return");

            case 2:
              if (!(typeof onBeforeOpen === 'function')) {
                _context.next = 8;
                break;
              }

              _context.next = 5;
              return onBeforeOpen();

            case 5:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              setVisible(true);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleInputClick.apply(this, arguments);
  }

  var ModalRender = Modal;
  var PickerModalProps = ModalProps; // 自定义弹窗

  if (ModalComponent) {
    ModalRender = ModalComponent;
  } // Picker弹窗: 需要传入定制属性
  else {
      PickerModalProps = _extends({
        maskProps: maskProps,
        submitProps: submitProps,
        cancelProps: cancelProps,
        slotProps: slotProps
      }, ModalProps);
    } // 允许清空


  if (allowClear) {
    if (readOnly || disabled) {
      allowClear = false;
    } else {
      allowClear = 'readOnly';
    }
  }

  return /*#__PURE__*/React.createElement(Fragment, null, children && /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef
  }, props, {
    onClick: handleInputClick
  }), children), !children && /*#__PURE__*/React.createElement(Input.Text, _extends({
    ref: rootRef,
    allowClear: allowClear,
    value: Utils.getDisplayValue(value),
    readOnly: true,
    onClick: handleInputClick,
    onChange: onChange
  }, props)), /*#__PURE__*/React.createElement(ModalRender, _extends({
    ref: modalRef,
    portal: portal,
    getComboDOM: function getComboDOM() {
      return rootRef.current;
    },
    maskClosable: maskClosable,
    multiple: multiple,
    value: value,
    list: list,
    onBeforeChange: onBeforeChange,
    onChange: onChange,
    onVisibleChange: setVisible
  }, PickerModalProps, {
    visible: ModalProps.visible === undefined ? visible : ModalProps.visible
  })));
});
export default Combo;