var _excluded = ["visible", "caption"],
    _excluded2 = ["visible", "caption"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import locale from './../../locale';
var Head = forwardRef(function (_ref, ref) {
  var multiple = _ref.multiple,
      captionProps = _ref.captionProps,
      submitProps = _ref.submitProps,
      cancelProps = _ref.cancelProps,
      onSubmitClick = _ref.onSubmitClick,
      onCancelClick = _ref.onCancelClick;

  // 确定和取消按钮
  var _ref2 = cancelProps || {},
      cancelVisible = _ref2.visible,
      cancelCaption = _ref2.caption,
      otherCancelProps = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var _ref3 = submitProps || {},
      submitVisible = _ref3.visible,
      submitCaption = _ref3.caption,
      otherSubmitProps = _objectWithoutPropertiesLoose(_ref3, _excluded2); // 点击确定


  function handleSubmitClick(e) {
    e.stopPropagation();
    if (submitProps.onClick) submitProps.onClick(e);
    if (onSubmitClick) onSubmitClick(e);
  } // 点击取消


  function handleCancelClick(e) {
    e.stopPropagation();
    if (cancelProps.onClick) cancelProps.onClick(e);
    if (onCancelClick) onCancelClick(e);
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "picker-header",
    ref: ref
  }, cancelVisible !== false && /*#__PURE__*/React.createElement("div", _extends({}, otherCancelProps, {
    className: "picker-cancel" + (otherCancelProps.className ? ' ' + otherCancelProps.className : ''),
    onClick: handleCancelClick
  }), cancelCaption || locale('取消', 'cancel')), /*#__PURE__*/React.createElement("div", _extends({}, captionProps, {
    className: "picker-header-title" + ((captionProps === null || captionProps === void 0 ? void 0 : captionProps.className) ? ' ' + (captionProps === null || captionProps === void 0 ? void 0 : captionProps.className) : '')
  }), captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption), submitVisible !== false && /*#__PURE__*/React.createElement("div", _extends({}, otherSubmitProps, {
    className: "picker-submit" + (otherSubmitProps.className ? ' ' + otherSubmitProps.className : '') + (multiple ? '' : ' disabled'),
    onClick: handleSubmitClick
  }), submitCaption || locale('完成', 'finish')));
});
export default Head;