var _excluded = ["animation", "style", "getChildrenDOM", "children", "visible", "onVisibleChange"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useEffect, useImperativeHandle, useState } from 'react';
import Popup from './Popup';
import Utils from './Utils';
var Tooltip = forwardRef(function (_ref, ref) {
  var _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'slideDownLeft' : _ref$animation,
      style = _ref.style,
      getChildrenDOM = _ref.getChildrenDOM,
      children = _ref.children,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = useRef(null);
  var childrenRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 非受控显隐

  var _useState = useState(false),
      autoVisible = _useState[0],
      setAutoVisible = _useState[1]; // 受控显隐时, 需要更新容器位置


  useEffect(function () {
    var childrenDOM = childrenRef.current;

    if (typeof getChildrenDOM === 'function') {
      var _childrenDOM;

      childrenDOM = getChildrenDOM();

      if (typeof ((_childrenDOM = childrenDOM) === null || _childrenDOM === void 0 ? void 0 : _childrenDOM.getRootDOM) === 'function') {
        childrenDOM = childrenDOM.getRootDOM();
      }
    }

    if (visible && childrenDOM) {
      Utils.updateContainerPosition({
        source: rootRef.current,
        target: childrenDOM,
        style: style,
        animation: animation
      });
    }
  }, [visible]); // eslint-disable-line
  // 非受控显隐, 为子元素增加点击事件显隐

  var newChildren = React.Children.toArray(children);

  if (newChildren.length === 1) {
    newChildren = React.cloneElement(children, {
      ref: childrenRef,
      onClick: function onClick(e) {
        Utils.updateContainerPosition({
          source: rootRef.current,
          target: e.currentTarget,
          style: style,
          animation: animation
        });

        if (typeof visible !== 'boolean') {
          setAutoVisible(!autoVisible);
        }
      }
    });
  } else {
    newChildren = children;
  } // 点击遮罩隐藏


  function handleVisibleChange(newVisible) {
    if (typeof visible !== 'boolean') {
      setAutoVisible(newVisible);
    }

    if (typeof onVisibleChange === 'function') {
      onVisibleChange(newVisible);
    }
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Popup, _extends({
    ref: rootRef,
    animation: animation,
    style: style,
    visible: typeof visible === 'boolean' ? visible : autoVisible,
    onVisibleChange: handleVisibleChange
  }, props)), newChildren);
});
export default Tooltip;