"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _locale = _interopRequireDefault(require("./../../locale"));

var _excluded = ["portal", "getComboDOM", "value", "list", "onBeforeChange", "onChange", "visible", "maskClosable", "onVisibleChange", "maskProps", "cancelProps", "groupProps", "optionProps", "animation"],
    _excluded2 = ["onClick", "visible", "caption"],
    _excluded3 = ["onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Modal = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {
    visible: true
  } : _ref$cancelProps,
      _ref$groupProps = _ref.groupProps,
      groupProps = _ref$groupProps === void 0 ? {} : _ref$groupProps,
      _ref$optionProps = _ref.optionProps,
      optionProps = _ref$optionProps === void 0 ? {} : _ref$optionProps,
      _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'slideUp' : _ref$animation,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 过滤非法数据
  list = list.filter(function (item) {
    if (!item || !item.id && !item.name) return false;
    return true;
  });
  var rootRef = (0, _react.useRef)(null); // 节点

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 构建动画

  var animationClassName = '';

  switch (animation) {
    case 'slideLeft':
      animationClassName = 'popup-animation right-middle';
      break;

    case 'slideRight':
      animationClassName = 'popup-animation left-middle';
      break;

    case 'slideUp':
      animationClassName = 'popup-animation bottom-center';
      break;

    case 'slideDown':
      animationClassName = 'popup-animation top-center';
      break;

    case 'zoom':
      animationClassName = 'popup-animation middle';
      break;

    case 'fade':
      animationClassName = 'popup-animation middle';
      break;

    case 'none':
      animationClassName = '';
      break;

    default:
      animationClassName = 'popup-animation middle';
  } // 动画时长


  var durationStyle = {};

  if (typeof duration === 'number') {
    durationStyle = {
      WebkitTransitionDuration: duration + 'ms'
    };
  } // 剔除掉onClick事件, 因为在容器onClick已经回调了


  var otherMaskProps = filterProps(maskProps);
  var otherGroupProps = filterProps(groupProps);
  var otherOptionProps = filterProps(optionProps);

  var cancelOnClick = cancelProps.onClick,
      cancelVisible = cancelProps.visible,
      cancelCaption = cancelProps.caption,
      otherCancelProps = _objectWithoutPropertiesLoose(cancelProps, _excluded2); // 点击容器


  function handleClick(_x) {
    return _handleClick.apply(this, arguments);
  } // 判断是否选中


  function _handleClick() {
    _handleClick = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(e) {
      var target, item, index, goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              target = e.target; // 点击选项

              if (!target.classList.contains('actionsheet-option')) {
                _context.next = 18;
                break;
              }

              item = null;
              index = null;
              index = target.getAttribute('data-index');
              index = Number(index);
              item = list[index] || null; // 触发点击事件

              if (optionProps === null || optionProps === void 0 ? void 0 : optionProps.onClick) optionProps.onClick(e); // 修改提示

              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 14;
                break;
              }

              _context.next = 11;
              return onBeforeChange([item]);

            case 11:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 14;
                break;
              }

              return _context.abrupt("return");

            case 14:
              // 触发onChange事件
              if (onChange) onChange([item]);
              if (onVisibleChange) onVisibleChange(false);
              _context.next = 27;
              break;

            case 18:
              if (!target.classList.contains('actionsheet-cancel')) {
                _context.next = 23;
                break;
              }

              // 触发点击事件
              if (cancelProps === null || cancelProps === void 0 ? void 0 : cancelProps.onClick) cancelProps.onClick(e);
              if (onVisibleChange) onVisibleChange(false);
              _context.next = 27;
              break;

            case 23:
              if (!target.classList.contains('actionsheet-mask')) {
                _context.next = 27;
                break;
              }

              if (maskProps.onClick) maskProps.onClick(e);
              if (maskClosable && onVisibleChange) onVisibleChange(false);
              return _context.abrupt("return");

            case 27:
              // 区分点击事件
              e.stopPropagation();

            case 28:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleClick.apply(this, arguments);
  }

  function getIsActive(item) {
    if (Array.isArray(value) && value.length) {
      var _value$;

      return ((_value$ = value[0]) === null || _value$ === void 0 ? void 0 : _value$.id) === item.id;
    }

    return false;
  } // 获取项的className


  function getOptionClassName(item) {
    var className = ['actionsheet-option'];

    if (otherOptionProps.className) {
      className.push(otherOptionProps.className);
    }

    if (getIsActive(item)) {
      className.push('active');
    }

    return className.join(' ');
  } // 过滤已经回调的属性


  function filterProps(props) {
    if (!props) return {};

    var onClick = props.onClick,
        otherProps = _objectWithoutPropertiesLoose(props, _excluded3);

    return _extends({}, otherProps);
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, otherMaskProps, {
    className: "mask actionsheet-mask" + (otherMaskProps.className ? ' ' + otherMaskProps.className : '') + (visible ? ' active' : ''),
    style: Object.assign({}, durationStyle, otherMaskProps.style || {}),
    onClick: handleClick
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({
    "data-animation": animation
  }, props, {
    className: "actionsheet" + (animationClassName ? ' ' + animationClassName : '') + (props.className ? ' ' + props.className : '') + (visible ? ' active' : ''),
    style: Object.assign({}, durationStyle, props.style || {})
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, otherGroupProps, {
    className: "actionsheet-group" + (otherGroupProps.className ? ' ' + otherGroupProps.className : '')
  }), list && list.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({}, otherOptionProps, {
      className: getOptionClassName(item),
      key: index,
      "data-index": index
    }), item.name);
  })), cancelVisible && /*#__PURE__*/_react["default"].createElement("div", _extends({}, otherCancelProps, {
    className: "actionsheet-cancel" + (otherCancelProps.className ? ' ' + otherCancelProps.className : '')
  }), cancelCaption || (0, _locale["default"])('取消', 'cancel')))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Modal, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;