"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _instance = _interopRequireDefault(require("./../Context/instance.js"));

var _excluded = ["portal", "show", "animation", "duration", "maskAttribute", "caption", "captionAttribute", "icon", "contentAttribute", "submitCaption", "submitAttribute", "cancelCaption", "cancelAttribute", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 弹框

/**
 * @deprecated since version 5.2.8
 * 请使用Modal
 */
var Alert = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      show = _ref.show,
      _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'zoom' : _ref$animation,
      duration = _ref.duration,
      _ref$maskAttribute = _ref.maskAttribute,
      maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
      caption = _ref.caption,
      _ref$captionAttribute = _ref.captionAttribute,
      captionAttribute = _ref$captionAttribute === void 0 ? {} : _ref$captionAttribute,
      icon = _ref.icon,
      _ref$contentAttribute = _ref.contentAttribute,
      contentAttribute = _ref$contentAttribute === void 0 ? {} : _ref$contentAttribute,
      submitCaption = _ref.submitCaption,
      _ref$submitAttribute = _ref.submitAttribute,
      submitAttribute = _ref$submitAttribute === void 0 ? {} : _ref$submitAttribute,
      cancelCaption = _ref.cancelCaption,
      _ref$cancelAttribute = _ref.cancelAttribute,
      cancelAttribute = _ref$cancelAttribute === void 0 ? {} : _ref$cancelAttribute,
      children = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  // context
  var context = (0, _react.useContext)(_instance["default"]) || {};

  var locale = context.locale || function (remark) {
    return remark || '';
  }; // 构建动画


  var animationClassName = '';

  switch (animation) {
    case 'slideLeft':
      animationClassName = 'popup-animation right-middle';
      break;

    case 'slideRight':
      animationClassName = 'popup-animation left-middle';
      break;

    case 'slideUp':
      animationClassName = 'popup-animation bottom-center';
      break;

    case 'slideDown':
      animationClassName = 'popup-animation top-center';
      break;

    case 'zoom':
      animationClassName = 'popup-animation middle';
      break;

    case 'fade':
      animationClassName = 'popup-animation middle';
      break;

    case 'none':
      animationClassName = '';
      break;

    default:
      animationClassName = 'popup-animation middle';
  } // 动画时长


  var durationStyle = {};

  if (typeof duration === 'number') {
    durationStyle = {
      WebkitTransitionDuration: duration + 'ms'
    };
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref
  }, maskAttribute, {
    className: "mask alert-mask" + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : ''),
    style: Object.assign({}, durationStyle, maskAttribute.style || {})
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({
    "data-animation": animation
  }, others, {
    className: "alert" + (animationClassName ? ' ' + animationClassName : '') + (others.className ? ' ' + others.className : '') + (show ? ' active' : ''),
    style: Object.assign({}, durationStyle, others.style || {})
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "alert-body"
  }, caption && /*#__PURE__*/_react["default"].createElement("div", _extends({}, captionAttribute, {
    className: "alert-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
  }), caption), /*#__PURE__*/_react["default"].createElement("div", _extends({}, contentAttribute, {
    className: "alert-content" + (contentAttribute.className ? ' ' + contentAttribute.className : '')
  }), icon, children)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "alert-footer"
  }, cancelAttribute.onClick && /*#__PURE__*/_react["default"].createElement("div", _extends({}, cancelAttribute, {
    className: "alert-cancel button" + (cancelAttribute.className ? ' ' + cancelAttribute.className : '')
  }), cancelCaption || locale('取消', 'cancel')), submitAttribute.onClick && /*#__PURE__*/_react["default"].createElement("div", _extends({}, submitAttribute, {
    className: "alert-submit button" + (submitAttribute.className ? ' ' + submitAttribute.className : '')
  }), submitCaption || locale('确定', 'ok'))))), portal || context.portal || document.getElementById('root') || document.body);
});
var _default = Alert;
exports["default"] = _default;
module.exports = exports.default;