"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _locale = _interopRequireDefault(require("./../locale"));

var _excluded = ["children", "caption", "type"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// type: loading,noMore,failed
var BottomFinish = (0, _react.forwardRef)(function (_ref, ref) {
  var children = _ref.children,
      caption = _ref.caption,
      type = _ref.type,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return rootRef.current;
  }); // 获取提示

  function getCaption() {
    if (caption) return caption;

    if (type === 'loading') {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "body-pull-push-box"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "body-pull-push-icon body-pull-push-icon-loading"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "body-pull-push-caption"
      }, (0, _locale["default"])('正在加载...', 'loading')));
    } else {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "body-pull-push-box"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "body-pull-push-caption"
      }, type === 'noMore' ? (0, _locale["default"])('没有更多数据了', 'no_more_data') : (0, _locale["default"])('加载失败, 请稍后再试', 'refreshing_failed')));
    }
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef,
    className: "SID-Dragrefresh-ErrorContainer body-pull-push",
    style: {
      height: '50px'
    }
  }, others), !children && getCaption(), children);
});
var _default = BottomFinish;
exports["default"] = _default;
module.exports = exports.default;