"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Utils = _interopRequireDefault(require("./Utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var ListItem = (0, _react.forwardRef)(function (_ref, ref) {
  var optionProps = _ref.optionProps,
      list = _ref.list,
      loadData = _ref.loadData,
      currentList = _ref.currentList,
      onCurrentListChange = _ref.onCurrentListChange,
      tabs = _ref.tabs,
      onTabsChange = _ref.onTabsChange,
      chooseTab = _ref.chooseTab,
      onChooseTabChange = _ref.onChooseTabChange,
      onChange = _ref.onChange,
      onBeforeSelectOption = _ref.onBeforeSelectOption;
  // 加载时禁用点击
  var loadingRef = (0, _react.useRef)(null); // 点击项

  function handleOptionClick(_x, _x2) {
    return _handleOptionClick.apply(this, arguments);
  } // 判断是否选中


  function _handleOptionClick() {
    _handleOptionClick = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(e, item) {
      var newCurrentList, allowLoadChildren;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              e.stopPropagation();

              if (!loadingRef.current) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              loadingRef.current = true;
              if (optionProps.onClick) optionProps.onClick(e); // 更新tabs

              tabs = _Utils["default"].addOptionToTabs(tabs, item);
              if (onTabsChange) onTabsChange(tabs); // 获取列表数据

              newCurrentList = null; // 获取子数据前阻止方法

              allowLoadChildren = true;

              if (!onBeforeSelectOption) {
                _context.next = 13;
                break;
              }

              _context.next = 12;
              return onBeforeSelectOption(tabs);

            case 12:
              allowLoadChildren = _context.sent;

            case 13:
              if (!allowLoadChildren) {
                _context.next = 17;
                break;
              }

              _context.next = 16;
              return _Utils["default"].getChildrenList(list, tabs, item, loadData);

            case 16:
              newCurrentList = _context.sent;

            case 17:
              // 没有数据则直接调用onChange
              if (!Array.isArray(newCurrentList) || !newCurrentList.length) {
                chooseTab = null;
                if (onChooseTabChange) onChooseTabChange(chooseTab); // 选中最后一项

                tabs[tabs.length - 1].active = true;
                if (onChange) onChange(tabs);
              } // 有数据则刷新列表
              else {
                  chooseTab = _Utils["default"].getChooseTab(tabs, true);
                  if (onChooseTabChange) onChooseTabChange(chooseTab);
                  if (onCurrentListChange) onCurrentListChange(newCurrentList);
                }

              loadingRef.current = false;

            case 19:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleOptionClick.apply(this, arguments);
  }

  function getActiveOptionClass(item) {
    if (!Array.isArray(tabs) || !tabs.length) return '';
    if (!(item === null || item === void 0 ? void 0 : item.id)) return '';

    for (var _iterator = _createForOfIteratorHelperLoose(tabs), _step; !(_step = _iterator()).done;) {
      var tab = _step.value;

      if (item.id === tab.id) {
        return ' active';
      }
    }

    return '';
  }

  if (!Array.isArray(currentList) || !currentList.length) return null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "cascader-modal-list",
    ref: ref
  }, Array.isArray(currentList) && currentList.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({
      key: index
    }, optionProps, {
      className: "cascader-modal-option" + (optionProps.className ? ' ' + optionProps.className : '') + getActiveOptionClass(item),
      "data-index": index,
      onClick: function onClick(e) {
        return handleOptionClick(e, item);
      }
    }), /*#__PURE__*/_react["default"].createElement("p", {
      className: "cascader-modal-option-caption"
    }, item.name), /*#__PURE__*/_react["default"].createElement("i", {
      className: "cascader-modal-option-icon"
    }));
  }));
});
var _default = ListItem;
exports["default"] = _default;
module.exports = exports.default;