"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _locale = _interopRequireDefault(require("./../../locale"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = {
  /**
   * 数据转换
   */
  // 为原始数据补充parentid
  convertList: function convertList(list) {
    if (!Array.isArray(list) || !list.length) return [];
    return list.setDeepTreeParentId();
  },

  /**
   * 初始化选中项
   */
  initData: function () {
    var _initData = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(config) {
      var list, loadData, currentList, onCurrentListChange, onBeforeSelectOption, activeTab, tabs, onTabsChange, chooseTab, onChooseTabChange, newCurrentList, allowLoadChildren, childrenList;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              list = config.list, loadData = config.loadData, currentList = config.currentList, onCurrentListChange = config.onCurrentListChange, onBeforeSelectOption = config.onBeforeSelectOption, activeTab = config.activeTab, tabs = config.tabs, onTabsChange = config.onTabsChange, chooseTab = config.chooseTab, onChooseTabChange = config.onChooseTabChange; // 取兄弟节点

              _context.next = 3;
              return this.getSiblingList(list, tabs, activeTab, loadData);

            case 3:
              newCurrentList = _context.sent;
              // 判断是否允许加载子节点
              allowLoadChildren = true;

              if (!onBeforeSelectOption) {
                _context.next = 9;
                break;
              }

              _context.next = 8;
              return onBeforeSelectOption(tabs);

            case 8:
              allowLoadChildren = _context.sent;

            case 9:
              if (!allowLoadChildren) {
                _context.next = 14;
                break;
              }

              _context.next = 12;
              return this.getChildrenList(list, tabs, activeTab, loadData);

            case 12:
              childrenList = _context.sent;

              if (Array.isArray(childrenList) && childrenList.length) {
                // 清除原选中状态
                tabs = tabs.map(function (tab) {
                  delete tab.active;
                  return tab;
                }); // 选中“请选择”

                chooseTab = this.getChooseTab(tabs, true);
                if (onChooseTabChange) onChooseTabChange(chooseTab); // 列表显示子数据

                newCurrentList = childrenList;
              }

            case 14:
              // if (Array.isArray(newCurrentList) && newCurrentList.length) {
              //   if (onCurrentListChange) onCurrentListChange(newCurrentList)
              // }
              if (onCurrentListChange) onCurrentListChange(newCurrentList);
              if (onTabsChange) onTabsChange(tabs);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function initData(_x) {
      return _initData.apply(this, arguments);
    }

    return initData;
  }(),

  /**
   * 列表数据
   */
  // 获取子节点
  getChildrenList: function getChildrenList(list, tabs, currentItem, loadData) {
    return new Promise( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve) {
        var childrenList;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // 获取列表数据
                childrenList = null;

                if (!(Array.isArray(currentItem.children) && currentItem.children.length)) {
                  _context2.next = 5;
                  break;
                }

                childrenList = currentItem.children;
                _context2.next = 13;
                break;

              case 5:
                if (!(typeof loadData === 'function')) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 8;
                return loadData(tabs);

              case 8:
                childrenList = _context2.sent;

                // 当前项下增加children, 并修改children的parentid
                if (Array.isArray(childrenList) && childrenList.length) {
                  // 增加parentid
                  childrenList = childrenList.map(function (item) {
                    item.parentid = currentItem.id;
                    return item;
                  });
                  list.setDeepTreeNodeProp(currentItem.id, function (node) {
                    node.children = childrenList;
                  });
                }

                _context2.next = 13;
                break;

              case 12:
                childrenList = null;

              case 13:
                resolve(childrenList);

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x2) {
        return _ref.apply(this, arguments);
      };
    }());
  },
  // 获取兄弟节点
  getSiblingList: function getSiblingList(list, tabs, tab, loadData) {
    var _this = this;

    return new Promise( /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve) {
        var parentTabs, siblingList, parent, currentItem;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                // 父级tabs, 用于获取子级(当前节点的兄弟)数据
                parentTabs = Object.clone(tabs);
                parentTabs.pop(); // 兄弟列表

                siblingList = null; // 如果当前选中项有id, 则寻找其兄弟节点列表

                if (!(tab === null || tab === void 0 ? void 0 : tab.id)) {
                  _context3.next = 16;
                  break;
                }

                // 获取父节点
                parent = list.getDeepTreeParent(tab.id);

                if (!parent && tab.parentid) {
                  parent = list.getDeepTreeNode(tab.parentid);
                } // 有上级, 则获取上级的子级(当前节点的兄弟)数据


                if (!parent) {
                  _context3.next = 13;
                  break;
                }

                currentItem = list.getDeepTreeNode(parent.id);
                _context3.next = 10;
                return _this.getChildrenList(list, parentTabs, currentItem, loadData);

              case 10:
                siblingList = _context3.sent;
                _context3.next = 14;
                break;

              case 13:
                siblingList = list;

              case 14:
                _context3.next = 17;
                break;

              case 16:
                siblingList = null;

              case 17:
                resolve(siblingList);

              case 18:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x3) {
        return _ref2.apply(this, arguments);
      };
    }());
  },
  // 从list中补全信息到选中项
  getListNode: function getListNode(list, item) {
    if (!(item === null || item === void 0 ? void 0 : item.id)) return item;
    var node = list.getDeepTreeNode(item.id);
    return Object.assign({}, node, item);
  },

  /**
   * 页签控制
   */
  // 选中项增加
  addOptionToTabs: function addOptionToTabs(tabs, option) {
    if (!tabs) tabs = []; // 从选中位置加入

    var activeIndex = tabs.findIndex(function (tab) {
      return tab.active;
    });

    if (activeIndex > -1) {
      tabs.splice(activeIndex);
    }

    tabs.push(option); // 取消选中

    for (var _iterator = _createForOfIteratorHelperLoose(tabs), _step; !(_step = _iterator()).done;) {
      var tab = _step.value;
      delete tab.active;
    }

    return tabs;
  },
  // 生成请选择标签
  getChooseTab: function getChooseTab(argTabs, hasChildren) {
    var tabs = Object.clone(argTabs);

    if (!Array.isArray(tabs) || !tabs.length) {
      return {
        id: '',
        name: (0, _locale["default"])('请选择'),
        type: 'choose',
        active: true
      };
    }

    if (hasChildren) {
      var lastTab = tabs[tabs.length - 1];
      lastTab.name = (0, _locale["default"])('请选择');
      lastTab.type = 'choose';
      lastTab.active = true;
      return lastTab;
    }

    return null;
  }
};
exports["default"] = _default;
module.exports = exports.default;