"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _locale = _interopRequireDefault(require("./../../locale"));

var _Head = _interopRequireDefault(require("./../../Picker/Modal/Head"));

var _Tabs = _interopRequireDefault(require("./Tabs"));

var _ListItem = _interopRequireDefault(require("./ListItem"));

var _Utils = _interopRequireDefault(require("./Utils"));

var _excluded = ["portal", "getComboDOM", "maskClosable", "visible", "multiple", "value", "list", "onBeforeChange", "onChange", "onVisibleChange", "loadData", "onBeforeSelectOption", "maskProps", "submitProps", "cancelProps", "optionProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Modal = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      maskClosable = _ref.maskClosable,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      _ref$multiple = _ref.multiple,
      multiple = _ref$multiple === void 0 ? false : _ref$multiple,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      onVisibleChange = _ref.onVisibleChange,
      loadData = _ref.loadData,
      onBeforeSelectOption = _ref.onBeforeSelectOption,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      _ref$optionProps = _ref.optionProps,
      optionProps = _ref$optionProps === void 0 ? {} : _ref$optionProps,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)(value || []),
      tabs = _useState[0],
      setTabs = _useState[1];

  var _useState2 = (0, _react.useState)(null),
      chooseTab = _useState2[0],
      setChooseTab = _useState2[1];

  var _useState3 = (0, _react.useState)(list || []),
      currentList = _useState3[0],
      setCurrentList = _useState3[1]; // 补充parentid


  list = _Utils["default"].convertList(list); // 节点

  var rootRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    // 隐藏时置空所有
    if (!visible) {
      // 置空tabs
      setTabs(null); // 置空请选择

      setChooseTab(null); // 置空列表

      setCurrentList(null);
      return;
    } // 显示时更新tabs


    tabs = value; // eslint-disable-line
    // 没有选中时使用一级列表

    if (!Array.isArray(tabs) || !tabs.length) {
      // 置空tabs
      setTabs(null); // 补一个请选择

      chooseTab = _Utils["default"].getChooseTab(); // eslint-disable-line

      setChooseTab(chooseTab); // 使用初始化列表

      currentList = list; // eslint-disable-line

      setCurrentList(currentList);
      return;
    } // 传入的选中项可能会数据不充分, 需要补充数据


    tabs = tabs.map(function (tab) {
      return _Utils["default"].getListNode(list, tab);
    }); // 选中项

    var activeTab = tabs.filter(function (item) {
      if (item.active) {
        return true;
      }

      return false;
    });

    if (Array.isArray(activeTab) && activeTab.length) {
      activeTab = activeTab[0];
    } else {
      activeTab = tabs[tabs.length - 1];
      tabs[tabs.length - 1].active = true;
    }

    setTabs(tabs); // 无选中项, 默认选中最后一项

    _Utils["default"].initData({
      list: list,
      // 选中列表
      loadData: loadData,
      currentList: currentList,
      onCurrentListChange: setCurrentList,
      // 选中前判断
      onBeforeSelectOption: onBeforeSelectOption,
      // 页签
      activeTab: activeTab,
      tabs: tabs,
      onTabsChange: setTabs,
      // 请选择页签
      chooseTab: chooseTab,
      onChooseTabChange: setChooseTab
    });
  }, [visible]); // eslint-disable-line
  // 点击遮罩

  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  } // 点击确定


  function handleSubmitClick(e) {
    handleChange(tabs);
    e.stopPropagation();
  } // 点击取消


  function handleCancelClick(e) {
    if (onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  } // 修改回调


  function handleChange(_x) {
    return _handleChange.apply(this, arguments);
  }

  function _handleChange() {
    _handleChange = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(newValue) {
      var goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return onBeforeChange(newValue);

            case 3:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return");

            case 6:
              if (onChange) onChange(newValue);
              if (onVisibleChange) onVisibleChange(false);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleChange.apply(this, arguments);
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, maskProps, {
    className: "mask picker-mask" + (maskProps.className ? ' ' + maskProps.className : '') + (visible ? ' active' : ''),
    onClick: handleMaskClick
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    "data-animation": "slideUp",
    className: "cascader-modal popup-animation bottom-center" + (props.className ? ' ' + props.className : '') + (visible ? ' active' : ''),
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }), /*#__PURE__*/_react["default"].createElement(_Head["default"], {
    multiple: multiple,
    caption: (0, _locale["default"])('请选择所在地区', 'picker_district_title'),
    cancelProps: cancelProps,
    submitProps: submitProps,
    onSubmitClick: handleSubmitClick,
    onCancelClick: handleCancelClick
  }), /*#__PURE__*/_react["default"].createElement(_Tabs["default"], {
    list: list // 选中列表
    ,
    loadData: loadData,
    currentList: currentList,
    onCurrentListChange: setCurrentList // 页签
    ,
    tabs: tabs,
    onTabsChange: setTabs // 请选择页签
    ,
    chooseTab: chooseTab,
    onChooseTabChange: setChooseTab
  }), /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
    optionProps: optionProps,
    list: list // 选中列表
    ,
    loadData: loadData,
    currentList: currentList,
    onCurrentListChange: setCurrentList // 页签
    ,
    tabs: tabs,
    onTabsChange: setTabs // 请选择页签
    ,
    chooseTab: chooseTab,
    onChooseTabChange: setChooseTab // 修改
    ,
    onChange: handleChange // 阻止选择
    ,
    onBeforeSelectOption: onBeforeSelectOption
  }))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Modal, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;