"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  // 根据类型获取正确的format
  getFormat: function getFormat(type) {
    var format = '';

    switch (type) {
      case 'year':
        format = 'YYYY';
        break;

      case 'quarter':
        format = 'YYYY-Q';
        break;

      case 'month':
        format = 'YYYY-MM';
        break;

      case 'date':
        format = 'YYYY-MM-DD';
        break;

      case 'time':
        format = 'hh:mm';
        break;

      case 'datetime':
        format = 'YYYY-MM-DD hh:mm';
        break;

      default:
        format = 'YYYY-MM-DD';
    }

    return format;
  },
  // 显示名称
  getDisplayValue: function getDisplayValue(_ref) {
    var type = _ref.type,
        format = _ref.format,
        value = _ref.value;

    if (!format) {
      format = this.getFormat(type);
    } // 显示值


    var displayValue = '';

    if (value instanceof Date) {
      displayValue = value.format(format);
    }

    return displayValue;
  }
};
exports["default"] = _default;
module.exports = exports.default;