"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _locale = _interopRequireDefault(require("./../../locale"));

var _Head = _interopRequireDefault(require("./../../Picker/Modal/Head"));

var _instance = _interopRequireDefault(require("./instance.js"));

var _Utils = _interopRequireDefault(require("./Utils"));

var _excluded = ["portal", "getComboDOM", "maskClosable", "value", "list", "onBeforeChange", "onChange", "visible", "onVisibleChange", "maskProps", "submitProps", "cancelProps", "type", "min", "max", "onError"],
    _excluded2 = ["onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Modal = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'date' : _ref$type,
      min = _ref.min,
      max = _ref.max,
      onError = _ref.onError,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  if (!['year', 'quarter', 'month', 'date', 'time', 'datetimetype'].includes(type)) {
    console.error('SeedsUI-DatePicker:type类型不正确');
    type = 'date';
  } // 节点


  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    initInstance();
  }, []); // eslint-disable-line

  (0, _react.useEffect)(function () {
    if (instance.current) {
      if (visible) {
        handleUpdate();
        instance.current.show();
      } else {
        instance.current.hide();
      }
    }
  }, [visible]); // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects

  if (instance.current) {
    instance.current.params.onClickSubmit = handleSubmitClick;
    instance.current.params.onClickCancel = handleCancelClick;
    instance.current.params.onClickMask = handleMaskClick;
    instance.current.params.onScrollEnd = handleScrollEnd;
  } // 点击确认


  function handleSubmitClick(_x) {
    return _handleSubmitClick.apply(this, arguments);
  }

  function _handleSubmitClick() {
    _handleSubmitClick = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(e) {
      var newValue, activeKeys, goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // 获取选中项
              newValue = e.getActiveDate(e.activeOptions);
              activeKeys = e.activeOptions.map(function (n, i, a) {
                return n['id'];
              });
              e.setDefaultsByKeys(activeKeys);
              if (submitProps.onClick) submitProps.onClick(e);
              newValue = _Utils["default"].validateDate(newValue, {
                type: type,
                min: min,
                max: max,
                onError: onError
              });

              if (!(newValue === false)) {
                _context.next = 7;
                break;
              }

              return _context.abrupt("return");

            case 7:
              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 13;
                break;
              }

              _context.next = 10;
              return onBeforeChange(newValue);

            case 10:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 13;
                break;
              }

              return _context.abrupt("return");

            case 13:
              // 触发onChange事件
              if (onChange) onChange(newValue);
              if (onVisibleChange) onVisibleChange(false);

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleSubmitClick.apply(this, arguments);
  }

  function handleCancelClick(e) {
    if (cancelProps.onClick) cancelProps.onClick(e);
    if (onVisibleChange) onVisibleChange(false);
  }

  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
  }

  function handleScrollEnd(e) {
    // 根据月份算日
    if ((e.params.viewType === 'date' || e.params.viewType === 'datetime') && (e.activeSlot.index === 0 || e.activeSlot.index === 1)) {
      var year = e.activeOptions[0]['id'];
      var month = e.activeOptions[1]['id'];
      var defaultDay = e.activeOptions[2]['id'];
      e.updateDays(year, month, defaultDay); // 更新总天数
    } // 是否显示标题


    if (e.headerTitle) {
      e.headerTitle.innerHTML = e.getActiveWeekText();
    }
  }

  function handleUpdate() {
    instance.current.updateParams({
      viewType: type,
      yyUnit: (0, _locale["default"])('', 'picker_unit_year'),
      QQUnit: (0, _locale["default"])('', 'picker_unit_quarter'),
      MMUnit: (0, _locale["default"])('', 'picker_unit_month'),
      ddUnit: (0, _locale["default"])('', 'picker_unit_date'),
      hhUnit: (0, _locale["default"])('', 'picker_unit_hour'),
      mmUnit: (0, _locale["default"])('', 'picker_unit_minute')
    });

    var def = _Utils["default"].getDefaults(value);

    instance.current.setDefaults(def);
    instance.current.update(); // 是否显示标题

    if (instance.current.headerTitle) {
      instance.current.headerTitle.innerHTML = instance.current.getActiveWeekText();
    }
  }

  function initInstance() {
    if (!rootRef || !rootRef.current) return;

    var data = _Utils["default"].getData(list);

    var def = _Utils["default"].getDefaults(value); // render数据


    instance.current = new _instance["default"]({
      mask: rootRef.current,
      viewType: type,
      yearsData: data.yearsData,
      quartersData: data.quartersData,
      monthsData: data.monthsData,
      daysData: data.daysData,
      hoursData: data.hoursData,
      minutesData: data.minutesData,
      defaultYear: def.year,
      defaultQuarter: def.quarter,
      defaultMonth: def.month,
      defaultDay: def.day,
      defaultHour: def.hour,
      defaultMinute: def.minute,
      onClickMask: handleMaskClick,
      onClickCancel: handleCancelClick,
      onClickSubmit: handleSubmitClick,
      onScrollEnd: handleScrollEnd,
      onHid: function onHid(e) {},
      yyUnit: (0, _locale["default"])('', 'picker_unit_year'),
      // 年
      QQUnit: (0, _locale["default"])('', 'picker_unit_quarter'),
      // 季
      MMUnit: (0, _locale["default"])('', 'picker_unit_month'),
      // 月
      ddUnit: (0, _locale["default"])('', 'picker_unit_date'),
      // 日
      hhUnit: (0, _locale["default"])('', 'picker_unit_hour'),
      // 时
      mmUnit: (0, _locale["default"])('', 'picker_unit_minute') // 分

    });

    if (visible && instance) {
      setTimeout(function () {
        instance.current.show();
      }, 10);
    }
  } // 过滤已经回调的属性


  function filterProps(props) {
    if (!props) return {};

    var onClick = props.onClick,
        otherProps = _objectWithoutPropertiesLoose(props, _excluded2);

    return _extends({}, otherProps);
  } // 剔除掉onClick事件, 因为在instance时已经回调了


  var otherMaskProps = filterProps(maskProps);
  var otherSubmitProps = filterProps(submitProps);
  var otherCancelProps = filterProps(cancelProps);
  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, otherMaskProps, {
    className: "mask picker-mask" + (otherMaskProps.className ? ' ' + otherMaskProps.className : '')
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "picker" + (props.className ? ' ' + props.className : '')
  }), /*#__PURE__*/_react["default"].createElement(_Head["default"] // 为了启用确定按钮
  , {
    multiple: true // caption
    ,
    cancelProps: otherCancelProps,
    submitProps: otherSubmitProps
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-wrapper"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-layer"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-layer-frame"
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-slotbox"
  })))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Modal, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;