"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Combo = _interopRequireDefault(require("./../../Picker/Combo"));

var _RangeModal = _interopRequireDefault(require("./../RangeModal"));

var _Utils = _interopRequireDefault(require("./Utils"));

var _locale = _interopRequireDefault(require("./../../locale"));

var _excluded = ["separator", "caption", "min", "max", "type", "format", "ranges", "onError", "ModalProps", "value"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RangeCombo = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref2;

  var separator = _ref.separator,
      caption = _ref.caption,
      min = _ref.min,
      max = _ref.max,
      type = _ref.type,
      format = _ref.format,
      _ref$ranges = _ref.ranges,
      ranges = _ref$ranges === void 0 ? (_ref2 = {}, _ref2[(0, _locale["default"])('今天', 'datepicker-tooltip_today')] = [new Date(), new Date()], _ref2[(0, _locale["default"])('昨天', 'datepicker-tooltip_yesterday')] = [new Date().prevDate(), new Date().prevDate()], _ref2[(0, _locale["default"])('本月', 'datepicker-tooltip_this_month')] = [new Date().firstMonthDate(), new Date()], _ref2[(0, _locale["default"])('上月', 'datepicker-tooltip_last_month')] = [new Date().prevMonth().firstMonthDate(), new Date().prevMonth().lastMonthDate()], _ref2[(0, _locale["default"])('最近7天', 'datepicker-tooltip_last_days', ['7'])] = [new Date().prevDate(7), new Date()], _ref2[(0, _locale["default"])('最近30天', 'datepicker-tooltip_last_days', ['30'])] = [new Date().prevDate(30), new Date()], _ref2[(0, _locale["default"])('自定义时间', 'datepicker-tooltip_custom_date')] = 90, _ref2) : _ref$ranges,
      onError = _ref.onError,
      _ref$ModalProps = _ref.ModalProps,
      ModalProps = _ref$ModalProps === void 0 ? {} : _ref$ModalProps,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    var _rootRef$current, _rootRef$current2;

    return {
      getRootDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.getRootDOM,
      getModalDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current2 = rootRef.current) === null || _rootRef$current2 === void 0 ? void 0 : _rootRef$current2.getModalDOM,
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  }); // 实例化

  instance.current = {
    getDisplayValue: function getDisplayValue(value) {
      return _Utils["default"].getDisplayValue({
        type: type,
        format: format,
        separator: separator,
        value: value
      });
    }
  }; // 显示值

  var displayValue = instance.current.getDisplayValue(value);
  return /*#__PURE__*/_react["default"].createElement(_Combo["default"], _extends({
    ref: rootRef,
    value: displayValue,
    ModalComponent: _RangeModal["default"],
    ModalProps: _extends({
      separator: separator,
      caption: caption,
      value: value,
      min: min,
      max: max,
      type: type,
      ranges: ranges,
      onError: onError
    }, ModalProps)
  }, props));
});
var _default = RangeCombo;
exports["default"] = _default;
module.exports = exports.default;