"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Alert = _interopRequireDefault(require("./../Alert"));

var _InputDate = _interopRequireDefault(require("./../InputDate"));

var _locale = _interopRequireDefault(require("./../locale"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// 自定义时间
function DateRange(_ref) {
  var caption = _ref.caption,
      type = _ref.type,
      start = _ref.start,
      end = _ref.end,
      _ref$startInputDatePr = _ref.startInputDateProps,
      startInputDateProps = _ref$startInputDatePr === void 0 ? {} : _ref$startInputDatePr,
      _ref$endInputDateProp = _ref.endInputDateProps,
      endInputDateProps = _ref$endInputDateProp === void 0 ? {} : _ref$endInputDateProp,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      onSubmitBefore = _ref.onSubmitBefore,
      onChange = _ref.onChange;

  // 自定义日期数据
  var _useState = (0, _react.useState)(start),
      customStart = _useState[0],
      setCustomStart = _useState[1];

  var _useState2 = (0, _react.useState)(end),
      customEnd = _useState2[0],
      setCustomEnd = _useState2[1];

  (0, _react.useEffect)(function () {
    setCustomStart(start);
    setCustomEnd(end);
  }, [start, end]); // 点击自定义取消

  function handleCustomCancel() {
    if (onVisibleChange) onVisibleChange(false);
    setCustomStart(start);
    setCustomEnd(end);
  } // 点击自定义确定


  function handleCustomSubmit(e) {
    if (typeof onSubmitBefore === 'function') {
      if (!onSubmitBefore(e, [customStart, customEnd])) {
        return;
      }
    }

    if (onChange) {
      onChange(e, [customStart, customEnd]);
    }

    if (onVisibleChange) onVisibleChange(false);
  } // 修改自定义开始时间


  function handleCustomStartDate(e, value) {
    setCustomStart(value);
  } // 修改自定义结束时间


  function handleCustomEndDate(e, value) {
    setCustomEnd(value);
  }

  return /*#__PURE__*/_react["default"].createElement(_Alert["default"], {
    caption: caption || '',
    show: visible,
    submitAttribute: {
      onClick: handleCustomSubmit
    },
    cancelAttribute: {
      onClick: handleCustomCancel
    }
  }, /*#__PURE__*/_react["default"].createElement(_InputDate["default"], _extends({
    type: type || 'date',
    max: customEnd,
    value: customStart || start || '',
    onChange: handleCustomStartDate,
    placeholder: (0, _locale["default"])('请选择'),
    className: "datepopover-dialog-inputbox",
    pickerProps: {
      maskAttribute: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, startInputDateProps || {})), /*#__PURE__*/_react["default"].createElement(_InputDate["default"], _extends({
    type: type || 'date',
    min: customStart,
    value: customEnd || end || '',
    onChange: handleCustomEndDate,
    placeholder: (0, _locale["default"])('请选择'),
    className: "datepopover-dialog-inputbox",
    pickerProps: {
      maskAttribute: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, endInputDateProps || {})));
}

var _default = DateRange;
exports["default"] = _default;
module.exports = exports.default;