"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _locale = _interopRequireDefault(require("./../locale"));

var _excluded = ["rows", "toggleProps", "html", "children"],
    _excluded2 = ["visible", "expandText", "collapseText", "style", "className"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TOGGLE_EXPAND_TEXT = (0, _locale["default"])('展开', 'expand');
var TOGGLE_COLLAPSE_TEXT = (0, _locale["default"])('收缩', 'collapse');
var Ellipsis = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$rows = _ref.rows,
      rows = _ref$rows === void 0 ? 3 : _ref$rows,
      _ref$toggleProps = _ref.toggleProps,
      toggleProps = _ref$toggleProps === void 0 ? {
    visible: true,
    expandText: TOGGLE_EXPAND_TEXT,
    collapseText: TOGGLE_COLLAPSE_TEXT
  } : _ref$toggleProps,
      html = _ref.html,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 展开和收缩样式
  var visible = toggleProps.visible,
      expandText = toggleProps.expandText,
      collapseText = toggleProps.collapseText,
      style = toggleProps.style,
      className = toggleProps.className,
      otherToggleProps = _objectWithoutPropertiesLoose(toggleProps, _excluded2); // 只读时超过三行显示展开和收缩


  var contentRef = (0, _react.useRef)(null);
  var toggleRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getContentDOM: function getContentDOM() {
        return contentRef.current;
      },
      getToggleDOM: function getToggleDOM() {
        return toggleRef.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    if (toggleRef.current && contentRef.current) {
      // 滚动高度和容器高度不一致说明有更多
      if (Math.abs(contentRef.current.scrollHeight - contentRef.current.clientHeight) > 2) {
        toggleRef.current.innerHTML = expandText || TOGGLE_EXPAND_TEXT;
        toggleRef.current.style.display = 'inline-block';
      }
    }
  }, [contentRef]); // eslint-disable-line

  function handleToggle(e) {
    var visible = contentRef.current.classList.contains("nowrap" + rows);

    if (visible) {
      contentRef.current.classList.remove("nowrap" + rows);
      if (toggleRef.current) toggleRef.current.innerHTML = collapseText || TOGGLE_COLLAPSE_TEXT;
    } else {
      contentRef.current.classList.add("nowrap" + rows);
      if (toggleRef.current) toggleRef.current.innerHTML = expandText || TOGGLE_EXPAND_TEXT;
    }

    e.stopPropagation();
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: contentRef,
    className: "nowrap" + rows
  }, props, {
    dangerouslySetInnerHTML: html && typeof html === 'string' ? {
      __html: html
    } : null
  }), children), visible && /*#__PURE__*/_react["default"].createElement("span", _extends({
    ref: toggleRef
  }, otherToggleProps, {
    style: Object.assign({}, style, {
      display: 'none'
    }),
    className: "color-link" + (className ? ' ' + className : ''),
    onClick: handleToggle
  })));
});
var _default = Ellipsis;
exports["default"] = _default;
module.exports = exports.default;