"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Number = _interopRequireDefault(require("./../Number"));

var _excluded = ["disabled", "plusProps", "minusProps", "inputProps", "defaultValue", "value", "precision", "max", "min", "placeholder", "maxLength", "readOnly", "autoFocus", "autoSelect", "stepFocus", "licon", "liconProps", "ricon", "riconProps", "onClick", "onChange", "onBlur", "onFocus"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 数值框
var NumberBox = (0, _react.forwardRef)(function (_ref, ref) {
  var disabled = _ref.disabled,
      _ref$plusProps = _ref.plusProps,
      plusProps = _ref$plusProps === void 0 ? {} : _ref$plusProps,
      _ref$minusProps = _ref.minusProps,
      minusProps = _ref$minusProps === void 0 ? {} : _ref$minusProps,
      _ref$inputProps = _ref.inputProps,
      inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
      defaultValue = _ref.defaultValue,
      value = _ref.value,
      precision = _ref.precision,
      max = _ref.max,
      min = _ref.min,
      placeholder = _ref.placeholder,
      _ref$maxLength = _ref.maxLength,
      maxLength = _ref$maxLength === void 0 ? '16' : _ref$maxLength,
      readOnly = _ref.readOnly,
      autoFocus = _ref.autoFocus,
      autoSelect = _ref.autoSelect,
      stepFocus = _ref.stepFocus,
      licon = _ref.licon,
      liconProps = _ref.liconProps,
      ricon = _ref.ricon,
      riconProps = _ref.riconProps,
      onClick = _ref.onClick,
      onChange = _ref.onChange,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var inputRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    var _inputRef$current;

    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInputDOM: inputRef === null || inputRef === void 0 ? void 0 : (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.getInputDOM,
      getInputRef: function getInputRef() {
        return inputRef;
      }
    };
  });

  var _useState = (0, _react.useState)(false),
      minDisabled = _useState[0],
      setMinDisabled = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      maxDisabled = _useState2[0],
      setMaxDisabled = _useState2[1];

  (0, _react.useEffect)(function () {
    var inputDOM = _getInputDOM();

    var val = ((inputDOM === null || inputDOM === void 0 ? void 0 : inputDOM.value) ? inputDOM.value : value) || '';
    updateState(val);
  }, [value]); // eslint-disable-line
  // 获取文本框

  function _getInputDOM() {
    var _inputRef$current2;

    if (inputRef === null || inputRef === void 0 ? void 0 : (_inputRef$current2 = inputRef.current) === null || _inputRef$current2 === void 0 ? void 0 : _inputRef$current2.getInputDOM) {
      return inputRef.current.getInputDOM();
    }

    return null;
  } // 更新禁用状态


  function updateState(val) {
    if (!isNaN(min) && !isNaN(val) && Number(val) <= Number(min)) {
      setMinDisabled(true);
    } else {
      setMinDisabled(false);
    }

    if (!isNaN(max) && !isNaN(val) && Number(val) >= Number(max)) {
      setMaxDisabled(true);
    } else {
      setMaxDisabled(false);
    }
  } // 修改值回调


  function handleChange(val) {
    if (disabled) return;

    var inputDOM = _getInputDOM();

    if (!inputDOM) return; // 非受控组件需要操作DOM

    if (defaultValue || defaultValue === '') {
      inputDOM.value = val;
    }

    updateState(val);
    if (onChange) onChange(val);
  } // 点击减


  function handleMinus(e) {
    e.stopPropagation();
    if (disabled) return;

    var inputDOM = _getInputDOM();

    if (!inputDOM) return;
    var val = inputRef.current.correctNumber(Math.Calc.subtract(inputDOM.value, 1)); // Callback

    handleChange(val);
    if (minusProps.onClick) minusProps.onClick(e, val);

    if (stepFocus) {
      inputDOM.focus();
    }
  } // 点击加


  function handlePlus(e) {
    e.stopPropagation();
    if (disabled) return;

    var inputDOM = _getInputDOM();

    if (!inputDOM) return;
    if (isNaN(inputDOM === null || inputDOM === void 0 ? void 0 : inputDOM.value)) return;
    var val = inputRef.current.correctNumber(Math.Calc.add(inputDOM.value, 1)); // Callback

    handleChange(val);
    if (plusProps.onClick) plusProps.onClick(e, val);

    if (stepFocus) {
      inputDOM.focus();
    }
  } // 文本框属性


  if (!inputProps) {
    inputProps = {};
  }

  inputProps.className = inputProps.className ? inputProps.className + " numbox-input" : 'numbox-input'; // render

  function getInputDOM() {
    return /*#__PURE__*/_react["default"].createElement(_Number["default"], {
      ref: inputRef,
      className: "numbox-input-box",
      type: "number",
      precision: precision,
      inputProps: inputProps,
      defaultValue: defaultValue,
      value: value,
      min: min,
      max: max,
      maxLength: maxLength,
      disabled: disabled,
      readOnly: readOnly,
      placeholder: placeholder,
      onChange: handleChange,
      autoFocus: autoFocus,
      autoSelect: autoSelect,
      onFocus: onFocus,
      onBlur: onBlur
    });
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, others, {
    disabled: (!isNaN(min) && !isNaN(max) ? Number(min) >= Number(max) : false) || disabled,
    className: "numbox" + (others.className ? ' ' + others.className : '')
  }), /*#__PURE__*/_react["default"].createElement("input", _extends({
    value: "-",
    disabled: minDisabled
  }, plusProps, {
    type: "button",
    className: "numbox-button numbox-button-minus" + (plusProps.className ? ' ' + plusProps.className : ''),
    onClick: handleMinus
  })), licon && licon, liconProps && !Object.isEmptyObject(liconProps) && /*#__PURE__*/_react["default"].createElement("i", _extends({}, liconProps, {
    className: "licon icon" + (liconProps.className ? ' ' + liconProps.className : '')
  })), getInputDOM(), riconProps && !Object.isEmptyObject(riconProps) && /*#__PURE__*/_react["default"].createElement("i", _extends({}, riconProps, {
    className: "ricon icon" + (riconProps.className ? ' ' + riconProps.className : '')
  })), ricon && ricon, /*#__PURE__*/_react["default"].createElement("input", _extends({
    value: "+",
    disabled: maxDisabled
  }, minusProps, {
    type: "button",
    className: "numbox-button numbox-button-plus" + (minusProps.className ? ' ' + minusProps.className : ''),
    onClick: handlePlus
  })));
});
var _default = NumberBox;
exports["default"] = _default;
module.exports = exports.default;