"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _InputText = _interopRequireDefault(require("./../InputText"));

var _DateRange = _interopRequireDefault(require("./../DateRangePopover/DateRange"));

var _excluded = ["rangeProps", "value", "type", "startInputDateProps", "endInputDateProps", "onChange", "onClick", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputDateRange = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$rangeProps = _ref.rangeProps,
      rangeProps = _ref$rangeProps === void 0 ? {
    // 标题
    caption: '',
    // 分割线
    separator: ''
  } : _ref$rangeProps,
      value = _ref.value,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'date-range' : _ref$type,
      _ref$startInputDatePr = _ref.startInputDateProps,
      startInputDateProps = _ref$startInputDatePr === void 0 ? {} : _ref$startInputDatePr,
      _ref$endInputDateProp = _ref.endInputDateProps,
      endInputDateProps = _ref$endInputDateProp === void 0 ? {} : _ref$endInputDateProp,
      onChange = _ref.onChange,
      onClick = _ref.onClick,
      children = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      rangeVisible = _useState[0],
      setRangeVisible = _useState[1];

  var inputTextRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return inputTextRef.current;
  }); // 类型修改

  type = type.replace('-range', ''); // 开始和结束时间

  var start = null;
  var end = null;

  if (Array.isArray(value) && value.length === 2) {
    start = value[0];
    end = value[1];
  }

  var displayValue = ''; // 允许仅选中开始或者结束

  if ((start || end) && (typeof start === 'string' || typeof end === 'string')) {
    displayValue = "" + (start || '') + (rangeProps.separator || '~') + (end || '');
  } // 点击文本框


  function handleClickInput() {
    if (onClick) onClick.apply(void 0, arguments);
    if (others.readOnly) return;
    setRangeVisible(true);
  } // 开始时间和结束时间


  function handleChange(e, values) {
    if (inputTextRef.current) e.currentTarget = inputTextRef.current;

    if (onChange) {
      onChange(e, values);
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, children && /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: inputTextRef
  }, others, {
    onClick: handleClickInput
  }), children), !children && /*#__PURE__*/_react["default"].createElement(_InputText["default"], _extends({
    ref: inputTextRef
  }, others, {
    value: displayValue,
    type: "text",
    readOnly: true,
    onClick: handleClickInput
  })), /*#__PURE__*/_react["default"].createElement(_DateRange["default"], {
    caption: rangeProps.caption,
    visible: rangeVisible,
    type: type,
    startInputDateProps: startInputDateProps,
    endInputDateProps: endInputDateProps,
    start: start,
    end: end,
    onChange: handleChange,
    onVisibleChange: setRangeVisible
  }));
});
var _default = InputDateRange;
exports["default"] = _default;
module.exports = exports.default;