"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _MapUtil = _interopRequireDefault(require("./../../MapUtil"));

var _Notice = _interopRequireDefault(require("./../../Notice"));

var _locale = _interopRequireDefault(require("./../../locale"));

var _helper = _interopRequireDefault(require("./helper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BMap = function BMap(_ref) {
  var errMsg = _ref.errMsg,
      changeState = _ref.changeState,
      _ref$list = _ref.list,
      list = _ref$list === void 0 ? [] : _ref$list,
      defaultChecked = _ref.defaultChecked,
      onMapClose = _ref.onMapClose,
      callback = _ref.callback;
  var refWrapperEl = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    _MapUtil["default"].load({
      ak: '3pTjiH1BXLjASHeBmWUuSF83',
      success: function success() {
        initData();
      },
      fail: function fail() {
        changeState && changeState({
          errMsg: (0, _locale["default"])('地图库加载失败，请稍后再试！', 'ZKGJ031269')
        });
      }
    });
  }, []); // eslint-disable-line

  var onMapLocation = function onMapLocation() {
    _helper["default"].location(callback);
  };

  function initData() {
    if (!window.BMap) {
      // 如果有高德地图, 则加上 || !window.AMap
      changeState({
        errMsg: (0, _locale["default"])('地图库加载失败，请稍后再试！', 'ZKGJ031269')
      });
      return;
    }

    if (!refWrapperEl.current) {
      changeState({
        errMsg: (0, _locale["default"])('地图容器不存在', 'ZKGJ029837')
      });
      return;
    }

    _helper["default"].initMap(refWrapperEl.current, {
      defaultChecked: defaultChecked,
      onMapClose: onMapClose,
      onMapLocation: onMapLocation,
      list: list
    }, callback);
  }

  (0, _react.useEffect)(function () {
    if (_helper["default"].init && list) {
      _helper["default"].drawMap(list);
    }
  }, [list]); // eslint-disable-line

  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "map-container",
    ref: refWrapperEl
  }), errMsg && /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
    caption: errMsg
  }));
};

function areEqual(prevProps, nextProps) {
  return JSON.stringify(prevProps) === JSON.stringify(nextProps);
}

var _default = _react["default"].memo(BMap, areEqual);

exports["default"] = _default;
module.exports = exports.default;