"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _InputText = _interopRequireDefault(require("./../../InputText"));

var _Dialog = _interopRequireDefault(require("./../../Dialog"));

var _locale = _interopRequireDefault(require("./../../locale"));

var _MapSearch = _interopRequireDefault(require("./../../MapSearch"));

var _helper = _interopRequireDefault(require("./helper"));

var _excluded = ["disabled", "readOnly", "value", "onChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _default = function _default(_ref) {
  var _Object$keys, _ref2;

  var disabled = _ref.disabled,
      readOnly = _ref.readOnly,
      value = _ref.value,
      onChange = _ref.onChange,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      list = _useState2[0],
      setList = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      selected = _useState3[0],
      setSelected = _useState3[1];

  (0, _react.useEffect)(function () {
    setSelected(value || {});
  }, []); // eslint-disable-line

  var handleClick = function handleClick() {
    setVisible(true);
  };

  var handleMapClose = function handleMapClose() {
    setVisible(false);
  };

  var handleMapLocation = function handleMapLocation(list) {
    setList(list);
  };

  var handleChange = function handleChange(e) {
    _helper["default"].localSearch(e.target.value, handleMapLocation);
  };

  var handleCardClick = function handleCardClick(item) {
    var l = item.point;
    var list = [{
      lng: l.lng,
      lat: l.lat
    }];

    _helper["default"].setNewCenter(list);

    _helper["default"].drawMarkers(list);

    setSelected(item);
    onChange && onChange(item);
    handleMapClose();
  };

  var handleClear = function handleClear(e) {
    e.stopPropagation();
    setSelected({});
    onChange && onChange(null);
  };

  var handleCallback = function handleCallback(value) {
    _helper["default"].localSearch(value, handleMapLocation);
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, selected && ((_Object$keys = Object.keys(selected || {})) === null || _Object$keys === void 0 ? void 0 : _Object$keys.length) > 0 ? /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      return setVisible(true);
    },
    style: (_ref2 = {
      minHeight: '40px',
      padding: '6px 12px',
      display: 'flex'
    }, _ref2["padding"] = 0, _ref2)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1"
  }, /*#__PURE__*/_react["default"].createElement("div", null, selected.title || ''), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      color: '#707070'
    }
  }, selected.address || '')), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      margin: 'auto'
    }
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "icon icon-rdo-close-fill size18",
    style: {
      color: '#707070'
    },
    onClick: handleClear
  }))) : /*#__PURE__*/_react["default"].createElement(_InputText["default"], _extends({
    readOnly: true,
    className: "bg-white",
    placeholder: disabled || readOnly ? '' : (0, _locale["default"])('请选择'),
    inputAttribute: {
      style: {
        padding: 0
      }
    },
    style: {
      padding: 0,
      borderRadius: 4
    },
    ricon: disabled || readOnly ? null : /*#__PURE__*/_react["default"].createElement("i", {
      className: "input-location-icon-choose",
      style: {
        width: 24,
        height: 24,
        backgroundRepeat: 'no-repeat',
        backgroundSize: '100% 100%'
      }
    }),
    onClick: handleClick
  }, others)), visible && /*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
    portal: document.getElementById('root'),
    show: visible,
    animation: "slideUp",
    style: {
      width: '100%',
      height: '90%',
      borderRadius: '18px 18px 0 0',
      backgroundColor: '#ffffff'
    }
  }, /*#__PURE__*/_react["default"].createElement(_MapSearch["default"], {
    callback: handleCallback
  })));
};

exports["default"] = _default;
module.exports = exports.default;