"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _locale = _interopRequireDefault(require("./../locale"));

var _excluded = ["portal", "type", "maskProps", "icon", "iconProps", "captionProps", "children"],
    _excluded2 = ["caption"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 国际化数据
var Loading = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'floating' : _ref$type,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      icon = _ref.icon,
      iconProps = _ref.iconProps,
      _ref$captionProps = _ref.captionProps,
      captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var containerRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });

  var _captionProps$caption = captionProps.caption,
      caption = _captionProps$caption === void 0 ? (0, _locale["default"])('加载中...', 'loading') : _captionProps$caption,
      otherCaptionProps = _objectWithoutPropertiesLoose(captionProps, _excluded2);

  var content = null;

  if (type === 'custom') {
    // 自定义样式
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-custom" + (props.className ? ' ' + props.className : '')
    }), icon && icon, iconProps && /*#__PURE__*/_react["default"].createElement("span", _extends({}, iconProps, {
      className: "loading-custom-icon" + (iconProps.className ? ' ' + iconProps.className : '')
    })), caption && /*#__PURE__*/_react["default"].createElement("p", _extends({}, otherCaptionProps, {
      className: "loading-custom-caption" + (otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  } else if (type === 'filling') {
    // 填料环
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-filling active" + (props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-filling-icon"
    }));
  } else if (type === 'floating') {
    // 流光
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({
      ref: containerRef
    }, props, {
      className: "loading-floating animated" + (props.className ? ' ' + props.className : '')
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-icon"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    })), caption && /*#__PURE__*/_react["default"].createElement("div", _extends({}, otherCaptionProps, {
      className: "loading-floating-caption" + (otherCaptionProps.className ? ' ' + otherCaptionProps.className : '')
    }), caption));
  } // 组合Node


  var Node = /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, maskProps, {
    className: 'loading-mask mask active' + (maskProps.className ? ' ' + maskProps.className : '')
  }), content, children);

  if (portal) {
    return (0, _reactDom.createPortal)(Node, portal);
  }

  return Node;
});
var _default = Loading;
exports["default"] = _default;
module.exports = exports.default;