"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Bridge = _interopRequireDefault(require("./../../Bridge"));

var _locale = _interopRequireDefault(require("./../../locale"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = {
  // 获取定位
  getLocation: function getLocation(_ref) {
    var cacheTime = _ref.cacheTime,
        onChange = _ref.onChange,
        onError = _ref.onError;

    // 开始定位
    _Bridge["default"].getLocation({
      cacheTime: typeof cacheTime === 'number' ? cacheTime : 10000,
      type: 'gcj02',
      success: function () {
        var _success = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(data) {
          var result, address;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!data.address) {
                    _context.next = 3;
                    break;
                  }

                  // 赋值
                  if (onChange) {
                    data.value = data.address;
                    onChange(data);
                  }

                  return _context.abrupt("return");

                case 3:
                  _context.next = 5;
                  return _Bridge["default"].getAddress({
                    // 只支持gcj02
                    latitude: data.latitude,
                    longitude: data.longitude
                  });

                case 5:
                  result = _context.sent;
                  result = _extends({}, data, result);
                  address = result && result.address ? result.address : '';
                  result.value = address; // 没有地址则认为获取地址失败

                  if (!address) {
                    result = null;
                  }

                  if (onChange) {
                    onChange(result);
                  }

                case 11:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function success(_x) {
          return _success.apply(this, arguments);
        }

        return success;
      }(),
      fail: function fail(res) {
        // 赋值
        if (onChange) {
          onChange(null);
        }

        if (onError) {
          onError({
            errMsg: (0, _locale["default"])('定位失败, 请检查定位权限是否开启', 'hint_location_failed')
          });
        }
      }
    });
  }
};
exports["default"] = _default;
module.exports = exports.default;