"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Loading = _interopRequireDefault(require("./../../../../Loading"));

var _Toast = _interopRequireDefault(require("./../../../../Toast"));

var _excluded = ["instance", "value", "onChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Location(_ref) {
  var instance = _ref.instance,
      value = _ref.value,
      _onChange = _ref.onChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  function handleLocation() {
    if (!instance.current) return;

    _Loading["default"].show();

    instance.current.getLocation({
      onChange: function onChange(value) {
        _Loading["default"].hide();

        if (!value) return; // 视图更新

        instance.current.centerToPoint([value.longitude, value.latitude]);
        if (_onChange) _onChange(value);
      },
      onError: function onError(err) {
        _Loading["default"].hide();

        _Toast["default"].show(err.errMsg, {
          maskClickable: true
        });
      }
    });
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "map-location" + (props.className ? ' ' + props.className : ''),
    onClick: handleLocation
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "map-location-icon"
  }));
}

var _default = Location;
exports["default"] = _default;
module.exports = exports.default;