"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Modal = _interopRequireDefault(require("./../../Modal"));

var _Preview = _interopRequireDefault(require("./Map/Preview"));

var _Choose = _interopRequireDefault(require("./Map/Choose"));

var _excluded = ["ak", "value", "onChange", "visible", "onVisibleChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 地图标注
var LocationModal = (0, _react.forwardRef)(function (_ref, ref) {
  var ak = _ref.ak,
      value = _ref.value,
      onChange = _ref.onChange,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  function handleChange(newValue) {
    if (onChange) onChange(newValue);
    if (onVisibleChange) onVisibleChange(false);
  }

  return /*#__PURE__*/_react["default"].createElement(_Modal["default"], _extends({
    ref: ref,
    visible: visible,
    onVisibleChange: onVisibleChange
  }, props, {
    animation: "slideUp",
    className: "location-modal"
  }), visible === 'preview' && /*#__PURE__*/_react["default"].createElement(_Preview["default"], {
    ak: ak,
    value: value
  }), visible === 'choose' && /*#__PURE__*/_react["default"].createElement(_Choose["default"], {
    ak: ak,
    value: value,
    onChange: handleChange
  }));
});
var _default = LocationModal;
exports["default"] = _default;
module.exports = exports.default;