"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Device = _interopRequireDefault(require("./../Device"));

var _Header = _interopRequireDefault(require("./../Header"));

var _Titlebar = _interopRequireDefault(require("./../Titlebar"));

var _excluded = ["animation", "titlebarVisible", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Page = (0, _react.forwardRef)(function (_ref, ref) {
  var animation = _ref.animation,
      _ref$titlebarVisible = _ref.titlebarVisible,
      titlebarVisible = _ref$titlebarVisible === void 0 ? 'auto' : _ref$titlebarVisible,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 支持根据标题自动渲染Titlebar
  var titleText = _Device["default"].getUrlParameter('showTitlebar');

  if (titlebarVisible === 'auto') {
    // URL中包含titlebar参数显示
    titlebarVisible = location.href.indexOf('?showTitlebar=') !== -1 || location.href.indexOf('&showTitlebar=') !== -1; // 全局配置显示

    if (window.__SeedsUI_config__ && Object.prototype.toString.call(window.__SeedsUI_config__) === '[object Object]') {
      var _window$__SeedsUI_con, _window$__SeedsUI_con2;

      if ((_window$__SeedsUI_con = window.__SeedsUI_config__) === null || _window$__SeedsUI_con === void 0 ? void 0 : (_window$__SeedsUI_con2 = _window$__SeedsUI_con.Titlebar) === null || _window$__SeedsUI_con2 === void 0 ? void 0 : _window$__SeedsUI_con2.titlebarVisible) {
        titlebarVisible = true;
      }
    }
  }

  return /*#__PURE__*/_react["default"].createElement("section", _extends({
    ref: ref
  }, props, {
    className: 'page' + (props.className ? ' ' + props.className : ''),
    "data-animation": animation
  }), titlebarVisible ? /*#__PURE__*/_react["default"].createElement(_Header["default"], null, /*#__PURE__*/_react["default"].createElement(_Titlebar["default"], {
    caption: decodeURIComponent(decodeURIComponent(titleText || ''))
  })) : null, children);
});
var _default = Page;
exports["default"] = _default;
module.exports = exports.default;