"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Page = _interopRequireDefault(require("./../Page"));

var _instance = _interopRequireDefault(require("./instance.js"));

var _excluded = ["drag", "transition", "lSide", "lSideAttribute", "rSide", "rSideAttribute", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PagePull = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$drag = _ref.drag,
      drag = _ref$drag === void 0 ? true : _ref$drag,
      _ref$transition = _ref.transition,
      transition = _ref$transition === void 0 ? 'push' : _ref$transition,
      lSide = _ref.lSide,
      _ref$lSideAttribute = _ref.lSideAttribute,
      lSideAttribute = _ref$lSideAttribute === void 0 ? {} : _ref$lSideAttribute,
      rSide = _ref.rSide,
      _ref$rSideAttribute = _ref.rSideAttribute,
      rSideAttribute = _ref$rSideAttribute === void 0 ? {} : _ref$rSideAttribute,
      children = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (instance.current) return;
    initInstance();
  }, []);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });

  function initInstance() {
    if (!(rootRef === null || rootRef === void 0 ? void 0 : rootRef.current)) return;
    instance.current = new _instance["default"](rootRef.current, {
      drag: true,
      transition: transition || 'push',
      onShowedLeft: lSideAttribute.onShowed,
      onShowedRight: rSideAttribute.onShowed
    });
  } // 过滤已经回调的属性


  function filterProps(props) {
    if (!props) return props;
    var propsed = {};

    for (var n in props) {
      if (n !== 'onShowed') {
        propsed[n] = props[n];
      }
    }

    return propsed;
  } // 剔除掉onShowed事件, 因为在instance时已经回调了


  lSideAttribute = filterProps(lSideAttribute);
  rSideAttribute = filterProps(rSideAttribute);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "page-pull",
    ref: rootRef
  }, /*#__PURE__*/_react["default"].createElement(_Page["default"], others, children, /*#__PURE__*/_react["default"].createElement("div", {
    className: "mask"
  })), lSide && /*#__PURE__*/_react["default"].createElement("aside", _extends({}, lSideAttribute, {
    className: "page-side-left" + (lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
    "data-transition": transition
  }), lSide), rSide && /*#__PURE__*/_react["default"].createElement("aside", _extends({}, lSideAttribute, {
    className: "page-side-right" + (lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
    "data-transition": transition
  }), rSide));
});
var _default = PagePull;
exports["default"] = _default;
module.exports = exports.default;