"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _instance = _interopRequireDefault(require("./instance.js"));

var _Head = _interopRequireDefault(require("./Head"));

var _excluded = ["portal", "getComboDOM", "maskClosable", "visible", "value", "list", "onBeforeChange", "onChange", "onVisibleChange", "maskProps", "captionProps", "submitProps", "cancelProps", "slotProps"],
    _excluded2 = ["onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Modal = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      maskClosable = _ref.maskClosable,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$captionProps = _ref.captionProps,
      captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      _ref$slotProps = _ref.slotProps,
      slotProps = _ref$slotProps === void 0 ? {} : _ref$slotProps,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 过滤非法数据
  list = list.filter(function (item) {
    if (!item || !item.id && !item.name) return false;
    return true;
  }); // 节点

  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    initInstance();
  }, []); // eslint-disable-line

  (0, _react.useEffect)(function () {
    if (instance.current) {
      if (visible && list.length) {
        setDefault();
        instance.current.show();
      } else {
        instance.current.hide();
      }
    } else if (list && list.length > 0) {
      initInstance();
    }
  }, [visible]); // eslint-disable-line
  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects

  if (instance.current) {
    instance.current.params.onClickSubmit = handleSubmitClick;
    instance.current.params.onClickCancel = handleCancelClick;
    instance.current.params.onClickMask = handleMaskClick;
  } // 事件


  function handleSubmitClick(_x) {
    return _handleSubmitClick.apply(this, arguments);
  }

  function _handleSubmitClick() {
    _handleSubmitClick = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(e) {
      var newValue, goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              newValue = e.activeOptions;
              if (submitProps.onClick) submitProps.onClick(e); // 修改提示

              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 8;
                break;
              }

              _context.next = 5;
              return onBeforeChange(newValue);

            case 5:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              if (onChange) onChange(newValue);
              if (onVisibleChange) onVisibleChange(false);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleSubmitClick.apply(this, arguments);
  }

  function handleCancelClick(e) {
    if (cancelProps.onClick) cancelProps.onClick(e);
    if (onVisibleChange) onVisibleChange(false);
  }

  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
  } // 设置默认选中项


  function setDefault() {
    var defaultOpt = getDefaultOption();
    if (!defaultOpt) return;
    instance.current.clearSlots();
    instance.current.addSlot(list, defaultOpt.id || '', slotProps.className || 'text-center'); // 添加列,参数:数据,默认id,样式(lock样式为锁定列)
  }

  function getDefaultOption() {
    if (Array.isArray(value) && value.length) {
      return value[0];
    }

    if (list && list.length) {
      return list[0];
    }

    return null;
  } // 实例化


  function initInstance() {
    if (!list || !list.length || instance.current) {
      console.log('SeedsUI Picker: 参数list为空');
      return;
    } // render数据


    instance.current = new _instance["default"]({
      mask: rootRef.current,
      onClickMask: handleMaskClick,
      onClickCancel: handleCancelClick,
      onClickSubmit: handleSubmitClick,
      onHid: function onHid(e) {}
    }); // 默认项

    var defaultOpt = getDefaultOption();
    var id = '';
    if (defaultOpt && defaultOpt.id) id = defaultOpt.id;
    instance.current.addSlot(list, id, slotProps.className || 'text-center');

    if (visible && instance.current) {
      instance.current.show();
    }

    rootRef.current.instance = instance;
  } // 过滤已经回调的属性


  function filterProps(props) {
    if (!props) return {};

    var onClick = props.onClick,
        otherProps = _objectWithoutPropertiesLoose(props, _excluded2);

    return _extends({}, otherProps);
  } // 剔除掉onClick事件, 因为在instance时已经回调了


  var otherMaskProps = filterProps(maskProps);
  var otherSubmitProps = filterProps(submitProps);
  var otherCancelProps = filterProps(cancelProps);
  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, otherMaskProps, {
    className: "mask picker-mask" + (otherMaskProps.className ? ' ' + otherMaskProps.className : '')
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "picker" + (props.className ? ' ' + props.className : '')
  }), /*#__PURE__*/_react["default"].createElement(_Head["default"] // 为了启用确定按钮
  , {
    multiple: true,
    captionProps: captionProps,
    cancelProps: otherCancelProps,
    submitProps: otherSubmitProps
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-wrapper"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-layer"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-layer-frame"
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "picker-slotbox"
  })))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Modal, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;