"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _Checkbox = _interopRequireDefault(require("./../../Checkbox"));

var _excluded = ["multiple", "allowClear", "value", "list", "onBeforeChange", "onChange", "onVisibleChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CheckboxGroup = (0, _react.forwardRef)(function (_ref, ref) {
  var multiple = _ref.multiple,
      allowClear = _ref.allowClear,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 过滤非法数据
  list = list.filter(function (item) {
    if (!item || !item.id && !item.name) return false;
    return true;
  }); // 节点

  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)({
    equalsItem: equals
  });
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  }); // 判断是否相同

  function equals(item1, item2) {
    if (item1.id && item2.id) {
      return item1.id === item2.id;
    } else if (item1.name && item2.name) {
      return item1.name === item2.name;
    } else {
      return false;
    }
  } // 根据value判断此项是否为选中状态


  function getIsActive(item) {
    if (!Array.isArray(value) || !value.length) {
      return false;
    }

    for (var _iterator = _createForOfIteratorHelperLoose(value), _step; !(_step = _iterator()).done;) {
      var activeItem = _step.value;
      if (equals(item, activeItem)) return true;
      continue;
    }

    return false;
  } // 修改回调


  function handleChange(_x, _x2) {
    return _handleChange.apply(this, arguments);
  }

  function _handleChange() {
    _handleChange = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(checked, currentItem) {
      var newValue, goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              newValue = null;

              if (!multiple) {
                // 允许取消单选
                if (!checked && allowClear && Array.isArray(value) && value.length === 1) {
                  newValue = [];
                } else {
                  newValue = [currentItem];
                }
              } else {
                newValue = Object.clone(value);

                if (checked) {
                  newValue.push(currentItem);
                } else {
                  newValue = newValue.filter(function (activeItem) {
                    if (equals(currentItem, activeItem)) return false;
                    return true;
                  });
                }
              } // 修改提示


              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 8;
                break;
              }

              _context.next = 5;
              return onBeforeChange(newValue);

            case 5:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              if (onChange) onChange(newValue);
              if (onVisibleChange) onVisibleChange(false);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleChange.apply(this, arguments);
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, props, {
    className: "select-checkbox-group" + (props.className ? ' ' + props.className : '')
  }), list.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "select-checkbox-item",
      key: index
    }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
      type: "" + (!multiple ? 'radio' : 'checkbox'),
      disabled: props.disabled,
      captionProps: {
        caption: item.name
      },
      checked: getIsActive(item),
      onChange: function onChange(checked) {
        return handleChange(checked, item, index);
      }
    }));
  }));
});
var _default = CheckboxGroup;
exports["default"] = _default;
module.exports = exports.default;