"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _Head = _interopRequireDefault(require("./../../Picker/Modal/Head"));

var _excluded = ["portal", "getComboDOM", "maskClosable", "visible", "multiple", "value", "list", "onBeforeChange", "onChange", "onVisibleChange", "maskProps", "submitProps", "cancelProps", "optionProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Modal = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      maskClosable = _ref.maskClosable,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      multiple = _ref.multiple,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      _ref$optionProps = _ref.optionProps,
      optionProps = _ref$optionProps === void 0 ? {} : _ref$optionProps,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 过滤非法数据
  list = list.filter(function (item) {
    if (!item || !item.id && !item.name) return false;
    return true;
  }); // 节点

  var rootRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 显示时初始化选中项

  (0, _react.useEffect)(function () {
    if (visible) {
      updateActive();
    }
  }, [visible]); // 初始化选中项

  function updateActive() {
    var optionsDOM = getOptionsDOM();
    optionsDOM.forEach(function (option, index) {
      var isActive = getIsActive(list[index]);

      if (isActive) {
        option.classList.add('active');
      } else {
        option.classList.remove('active');
      }
    });
  } // 根据value判断此项是否为选中状态


  function getIsActive(item) {
    if (!Array.isArray(value) || !value.length) {
      return false;
    }

    var isActive = value.some(function (activeItem) {
      if (item.id && activeItem.id) {
        return item.id === activeItem.id;
      } else if (item.name && activeItem.name) {
        return item.name === activeItem.name;
      } else {
        return false;
      }
    });
    return isActive;
  } // 获取选中项DOM


  function getActiveOptionsDOM() {
    return [].slice.call(rootRef.current.querySelector('.select-modal-wrapper').querySelectorAll('.active'));
  } // 获取所有选项DOM


  function getOptionsDOM() {
    return [].slice.call(rootRef.current.querySelectorAll('.select-modal-option'));
  } // 修改回调


  function handleChange() {
    return _handleChange.apply(this, arguments);
  } // 点击确定


  function _handleChange() {
    _handleChange = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var newValue, goOn;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              newValue = getActiveOptionsDOM();
              newValue = newValue.map(function (option) {
                var index = option.getAttribute('data-index');
                return list[index];
              }); // 修改提示

              if (!(typeof onBeforeChange === 'function')) {
                _context.next = 8;
                break;
              }

              _context.next = 5;
              return onBeforeChange(newValue);

            case 5:
              goOn = _context.sent;

              if (goOn) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              if (onChange) onChange(newValue);
              if (onVisibleChange) onVisibleChange(false);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _handleChange.apply(this, arguments);
  }

  function handleSubmitClick(_x) {
    return _handleSubmitClick.apply(this, arguments);
  } // 点击取消


  function _handleSubmitClick() {
    _handleSubmitClick = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(e) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              handleChange();
              e.stopPropagation();

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _handleSubmitClick.apply(this, arguments);
  }

  function handleCancelClick(e) {
    if (onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  } // 点击项


  function handleOptionClick(e) {
    if (optionProps.onClick) optionProps.onClick(e);

    if (!multiple) {
      var options = getActiveOptionsDOM();
      options.forEach(function (option) {
        return option.classList.remove('active');
      });
    }

    e.target.classList.toggle('active');

    if (!multiple) {
      handleChange();
    }

    e.stopPropagation();
  } // 点击遮罩


  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, maskProps, {
    className: "mask picker-mask" + (maskProps.className ? ' ' + maskProps.className : '') + (visible ? ' active' : ''),
    onClick: handleMaskClick
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "select-modal" + (props.className ? ' ' + props.className : '') + (visible ? ' active' : '')
  }), /*#__PURE__*/_react["default"].createElement(_Head["default"], {
    multiple: multiple // caption
    ,
    cancelProps: cancelProps,
    submitProps: submitProps,
    onSubmitClick: handleSubmitClick,
    onCancelClick: handleCancelClick
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "select-modal-wrapper"
  }, list.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({
      key: index
    }, optionProps, {
      className: "select-modal-option" + (optionProps.className ? ' ' + optionProps.className : ''),
      "data-index": index,
      onClick: handleOptionClick
    }), /*#__PURE__*/_react["default"].createElement("p", {
      className: "select-modal-option-caption"
    }, item.name), /*#__PURE__*/_react["default"].createElement("i", {
      className: "select-modal-option-icon"
    }));
  })))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Modal, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;