"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _instance = _interopRequireDefault(require("./instance.js"));

var _excluded = ["multiple", "startTime", "endTime", "times", "onChange", "onError"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 时间段
var Timepart = (0, _react.forwardRef)(function (_ref, ref) {
  var multiple = _ref.multiple,
      _ref$startTime = _ref.startTime,
      startTime = _ref$startTime === void 0 ? '07:00' : _ref$startTime,
      _ref$endTime = _ref.endTime,
      endTime = _ref$endTime === void 0 ? '22:00' : _ref$endTime,
      times = _ref.times,
      onChange = _ref.onChange,
      onError = _ref.onError,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var instance = (0, _react.useRef)(null); // 记录两次点击

  var part1Ref = (0, _react.useRef)(null);
  var part2Ref = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    if (instance.current) return;
    initInstance();
  }, []);
  (0, _react.useEffect)(function () {
    if (!times) return;
    handleUpdate();
  }, [JSON.stringify(times)]);

  function initInstance() {
    if (!(rootRef === null || rootRef === void 0 ? void 0 : rootRef.current)) return;
    var clickCount = 0;
    instance.current = new _instance["default"](rootRef.current, {
      startTime: startTime,
      endTime: endTime,
      onClickPart: function onClickPart(s) {
        var e = s.event;

        if (e.target.classList.contains('active')) {
          e.target.classList.remove('active');
          clickCount = 0; // onChange

          handleChange();
          return;
        } // 如果不允许多选,发现有已选中的先清除


        if (!multiple) {
          if (s.container.querySelectorAll('.progress-legend.active').length) {
            s.removeProgress('active');
            clickCount = 0; // onChange

            handleChange();
            return;
          }
        } // 选中


        clickCount++;

        if (clickCount === 1) {
          // 如果点击了一次
          part1Ref.current = e.target;
          part1Ref.current.classList.add('active'); // onChange

          handleChange();
        } else if (clickCount === 2) {
          // 如果点击了两次
          part1Ref.current.classList.remove('active');
          part2Ref.current = e.target;
          var times = s.getTimesByParts(part1Ref.current, part2Ref.current);
          s.addProgress(times.startTime, times.endTime, 'active');
          clickCount = 0; // onChange

          handleChange();
        }
      },
      onContain: function onContain(e) {
        clickCount = 0;
        if (onError) onError(Object.assign(e || {}, {
          errMsg: '已包含其它时间段'
        }));
      },
      onCross: function onCross(e) {
        if (onError) onError(Object.assign(e || {}, {
          errMsg: '与其它时间段相交'
        }));
      },
      onClickProgress: function onClickProgress(s) {
        var e = s.event;

        if (e.target.classList.contains('active')) {
          // 根据data-id删除
          var id = e.target.getAttribute('data-id');
          [].slice.call(s.container.querySelectorAll(".timepart-progress[data-id=\"" + id + "\"]")).forEach(function (el) {
            el.parentNode.removeChild(el);
          }); // onChange

          handleChange();
        }
      },
      onClickWhite: function onClickWhite(s) {}
    });
  }

  function handleUpdate() {
    if (!Array.isArray(times)) return;

    for (var i = 0, time; time = times[i++];) {
      // eslint-disable-line
      if (time.className && time.startTime && time.endTime) {
        instance.current.addProgress(time.startTime, time.endTime, time.className, time.data || null, time.cover || false);
      }
    } // onChange


    handleChange();
  }

  function handleChange() {
    var times = instance.current.getTimes();
    var part = instance.current.container.querySelector('.timepart-part.active');

    if (part) {
      times.push({
        className: part.className.replace('timepart-part ', ''),
        startTime: part.startTime,
        endTime: part.endTime,
        data: part.getAttribute('data') || ''
      });
    }

    if (onChange) onChange(times);
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, others, {
    className: "timepart" + (others.className ? ' ' + others.className : '')
  }));
});
var _default = Timepart;
exports["default"] = _default;
module.exports = exports.default;