"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _excluded = ["portal", "position", "duration", "maskClickable", "visible", "onVisibleChange", "licon", "ricon", "maskProps", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Toast = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'middle' : _ref$position,
      _ref$duration = _ref.duration,
      duration = _ref$duration === void 0 ? 2000 : _ref$duration,
      _ref$maskClickable = _ref.maskClickable,
      maskClickable = _ref$maskClickable === void 0 ? true : _ref$maskClickable,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      onVisibleChange = _ref.onVisibleChange,
      licon = _ref.licon,
      ricon = _ref.ricon,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var containerRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });
  (0, _react.useEffect)(function () {
    handleDuration();
  }, [visible]); // eslint-disable-line
  // 显示数秒后，自动消失

  function handleDuration() {
    if (typeof duration !== 'number' || !duration || !onVisibleChange) {
      return;
    }

    if (rootRef.current.durationTimeout) window.clearTimeout(rootRef.current.durationTimeout);
    rootRef.current.durationTimeout = setTimeout(function () {
      onVisibleChange(false);
    }, duration);
  } // 获取激活状态样式


  function getActiveClass() {
    return visible ? ' active' : '';
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, maskProps, {
    className: "mask toast-mask" + (maskProps.className ? ' ' + maskProps.className : '') + (maskClickable ? ' toast-propagation' : '') + getActiveClass()
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: containerRef
  }, props, {
    className: "toast " + (position || 'middle') + (props.className ? ' ' + props.className : '') + getActiveClass()
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "toast-wrapper"
  }, licon && licon, /*#__PURE__*/_react["default"].createElement("div", {
    className: "toast-content"
  }, children), ricon && ricon))), portal || document.getElementById('root') || document.body);
});

var _default = _react["default"].memo(Toast, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});

exports["default"] = _default;
module.exports = exports.default;