"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _Utils = _interopRequireDefault(require("./Utils"));

var _excluded = ["portal", "content", "animation", "style", "maskProps", "visible", "maskClosable", "onVisibleChange", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Popup = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      content = _ref.content,
      animation = _ref.animation,
      style = _ref.style,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      visible = _ref.visible,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      onVisibleChange = _ref.onVisibleChange,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 构建动画
  var position = _Utils["default"].getAnimationPosition(animation);

  var dataAnimation = _Utils["default"].getDataAnimation(animation); // 点击遮罩


  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  } // 箭头颜色: 根据style中的backgroundColor和borderColor


  var arrowStyle = null;
  var arrowOuterStyle = null;
  var backgroundColor = style === null || style === void 0 ? void 0 : style.backgroundColor;
  var borderColor = style === null || style === void 0 ? void 0 : style.borderColor; // 从下往上弹

  if (position.indexOf('bottom') === 0) {
    arrowStyle = backgroundColor ? {
      borderTopColor: backgroundColor
    } : null;
    arrowOuterStyle = borderColor ? {
      borderTopColor: borderColor
    } : null;
  } // 从上往下弹
  else {
      arrowStyle = backgroundColor ? {
        borderBottomColor: backgroundColor
      } : null;
      arrowOuterStyle = borderColor ? {
        borderBottomColor: borderColor
      } : null;
    }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref,
    className: "mask tooltip-mask" + (maskProps.className ? ' ' + maskProps.className : '') + (visible ? ' active' : '')
  }, maskProps, {
    onClick: handleMaskClick
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "popup-animation tooltip tooltip-bottom" + (position ? ' ' + position : '') + (props.className ? ' ' + props.className : '') + (visible ? ' active' : ''),
    style: style,
    "data-animation": dataAnimation
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tooltip-content"
  }, content), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tooltip-arrow-outer",
    style: arrowOuterStyle
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tooltip-arrow",
    style: arrowStyle
  }))), portal || document.getElementById('root') || document.body);
});
var _default = Popup;
exports["default"] = _default;
module.exports = exports.default;