"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Popup = _interopRequireDefault(require("./Popup"));

var _Utils = _interopRequireDefault(require("./Utils"));

var _excluded = ["animation", "style", "getChildrenDOM", "children", "visible", "onVisibleChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Tooltip = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'slideDownLeft' : _ref$animation,
      style = _ref.style,
      getChildrenDOM = _ref.getChildrenDOM,
      children = _ref.children,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  var childrenRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 非受控显隐

  var _useState = (0, _react.useState)(false),
      autoVisible = _useState[0],
      setAutoVisible = _useState[1]; // 受控显隐时, 需要更新容器位置


  (0, _react.useEffect)(function () {
    var childrenDOM = childrenRef.current;

    if (typeof getChildrenDOM === 'function') {
      var _childrenDOM;

      childrenDOM = getChildrenDOM();

      if (typeof ((_childrenDOM = childrenDOM) === null || _childrenDOM === void 0 ? void 0 : _childrenDOM.getRootDOM) === 'function') {
        childrenDOM = childrenDOM.getRootDOM();
      }
    }

    if (visible && childrenDOM) {
      _Utils["default"].updateContainerPosition({
        source: rootRef.current,
        target: childrenDOM,
        style: style,
        animation: animation
      });
    }
  }, [visible]); // eslint-disable-line
  // 非受控显隐, 为子元素增加点击事件显隐

  var newChildren = _react["default"].Children.toArray(children);

  if (newChildren.length === 1) {
    newChildren = _react["default"].cloneElement(children, {
      ref: childrenRef,
      onClick: function onClick(e) {
        _Utils["default"].updateContainerPosition({
          source: rootRef.current,
          target: e.currentTarget,
          style: style,
          animation: animation
        });

        if (typeof visible !== 'boolean') {
          setAutoVisible(!autoVisible);
        }
      }
    });
  } else {
    newChildren = children;
  } // 点击遮罩隐藏


  function handleVisibleChange(newVisible) {
    if (typeof visible !== 'boolean') {
      setAutoVisible(newVisible);
    }

    if (typeof onVisibleChange === 'function') {
      onVisibleChange(newVisible);
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Popup["default"], _extends({
    ref: rootRef,
    animation: animation,
    style: style,
    visible: typeof visible === 'boolean' ? visible : autoVisible,
    onVisibleChange: handleVisibleChange
  }, props)), newChildren);
});
var _default = Tooltip;
exports["default"] = _default;
module.exports = exports.default;